<%@ page contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="s" uri="/struts-tags"%>
<html>
<head>

<s:head theme="simple" />

<script type="text/javascript">
function submitForm(action) {
	document.EventsBoard_open.action = action;
	document.EventsBoard_open.submit();
}
</script>

</head>

<body>

<s:actionerror />

 <s:set name="dateFormat" value="%{'dd/MM/yyyy'}"/>
 <s:set name="timeFormat" value="%{'HH:mm'}"/>
 
 <s:if test="#session.user != null">
	 <s:set name="dateFormat" value="%{#session.user.dateFormat.format}"/>
	 <s:set name="timeFormat" value="%{#session.user.timeFormat.format}"/>
 </s:if>

<s:form action="EventsBoard_open" namespace="/eventsannouncement">

	<s:hidden name="month" />
	<s:hidden name="year" />

	<h1><s:property value="monthLabel" />&nbsp;<s:property
		value="year" /></h1>

	<!-- Events -->
	<h2><s:text name="message.events" /></h2>
	<s:if test="events != null && events.size > 0">
		<ul>
			<s:iterator id="event" value="events">
				<li>
					<s:if test="#session.user != null">
						<s:url id="url" action="Event_input" namespace="/eventsannouncement">
							<s:param name="eventDataManager.eventId" value="#event.id" />
						</s:url>
						<s:a href="%{url}"><s:property value="subject" /></s:a>
					</s:if>
					<s:else>
						<b><s:property value="subject" /></b>
					</s:else>
					<br>
					<s:if test="#event.allDay">
						<s:date name="start" format="%{#dateFormat + ' ' + #timeFormat}" />
						&nbsp;-&nbsp;
						<s:date name="end" format="%{#dateFormat + ' ' + #timeFormat}" />
					</s:if>
					<s:else>
						<s:date name="start" format="%{#dateFormat}" />
						&nbsp;-&nbsp;
						<s:date name="end" format="%{#dateFormat}" />
					</s:else>
					<br>
					<s:property value="description" />
					<br>
					<s:property value="city.name" /> - <s:property value="city.country.name" />
					<br>
					<a href="mailto:<s:property value="owner.email" />>"><s:property value="owner.fullName" /></a>
					<br>&nbsp;
				</li>				
			</s:iterator>
		</ul>
	</s:if>
	<s:else>
		<p><s:text name="message.no.events"></s:text></p>
	</s:else>
	<!-- Events -->

	<!-- Periodic Events -->
	<h2><s:text name="message.periodic.events" /></h2>
	<s:if test="periodicEvents != null && periodicEvents.size > 0">
		<ul>
			<s:iterator id="event" value="periodicEvents">
				<li>
					<s:if test="#session.user != null">
						<s:url id="url" action="Event_input" namespace="/eventsannouncement">
							<s:param name="eventDataManager.eventId" value="#event.id" />
						</s:url>
						<s:a href="%{url}"><s:property value="subject" /></s:a>
					</s:if>
					<s:else>
						<b><s:property value="subject" /></b>
					</s:else>
					<br>
					<s:date name="start" format="%{#dateFormat}" />
					&nbsp;-&nbsp;
					<s:date name="end" format="%{#dateFormat}" />
					<br>
					<s:text name="%{frequency.label}" />:
						<s:if test="allDay"> 
							<s:text name="allDay" />
						</s:if>
						<s:else>
							<s:date name="startTime" format="%{#timeFormat}" /> - <s:date name="endTime" format="%{#timeFormat}" />
						</s:else>
					<br>
					<s:property value="description" />
					<br>
					<s:property value="city.name" /> - <s:property value="city.country.name" />
					<br>
					<a href="mailto:<s:property value="owner.email" />>"><s:property value="owner.fullName" /></a>
					<br>&nbsp;
				</li>
			</s:iterator>
		</ul>
	</s:if>
	<s:else>
		<p><s:text name="message.no.events"></s:text></p>
	</s:else>
	<!-- Periodic Events -->

	<s:url id="url" action="EventsBoard_previousMonth" includeParams='none' />
	<s:a href="javascript:submitForm('%{url}')">
		<s:text name="message.previous.month" />
	</s:a>
	&nbsp;
	<s:url id="url" action="EventsBoard_nextMonth" includeParams='none' />
	<s:a href="javascript:submitForm('%{url}')">
		<s:text name="message.next.month" />
	</s:a>
</s:form>

</body>
</html>
