import org.hibernate.Session;

import br.pucrio.olis.domain.CalendarEvent;
import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.Frequency;
import br.pucrio.olis.domain.User;

/*
 * Created on Jun 22, 2008
 */

/**
 * @author Ingrid Nunes
 * 
 */
public class GenericSchemaGenerator extends SchemaGenerator {

	/*
	 * (non-Javadoc)
	 * 
	 * @see SchemaGenerator#createEvents(org.hibernate.Session)
	 */
	@Override
	public void createEvents(Session session) throws Exception {
		Event event = null;
		CalendarEvent calendarEvent = null;

		event = new Event();
		event.setAllDay(true);
		event.setCity(cities.get("sanFrancisco"));
		event.setDescription("Software Engineering and Knowledge Engineering");
		event.setLocation("Sofitel");
		event.setStart(getDate(1, 0, 0));
		event.setStartTime(null);
		event.setEnd(getDate(3, 23, 59));
		event.setEndTime(null);
		event.setSubject("SEKE 2008");
		event.setOwner(users.get("ingrid"));
		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);

		event = new Event();
		event.setAllDay(false);
		event.setCity(cities.get("estoril"));
		event.setDescription("Autonomous Agents and Multi-agent Systems");
		event.setEventsBoard(null);
		event.setLocation("Hotel Miragem Cascais");
		event.setStart(getDate(12, 8, 0));
		event.setStartTime(null);
		event.setEnd(getDate(16, 16, 30));
		event.setEndTime(null);
		event.setSubject("AAMAS 2008");
		event.setOwner(users.get("ingrid"));
		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("andrew").addEvents(calendarEvent);

		event = new Event();
		event.setAllDay(true);
		event.setCity(cities.get("caparica"));
		event.setDescription("European Agent Systems Summer School");
		event.setEventsBoard(null);
		event
				.setLocation("Faculdade de Ciencia e Tecnologia/Universidade de Nova Lisboa");
		event.setStart(getDate(5, 0, 0));
		event.setStartTime(null);
		event.setEnd(getDate(9, 23, 59));
		event.setEndTime(null);
		event.setSubject("EASSS 2008");
		event.setOwner(users.get("ingrid"));
		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("elder").addEvents(calendarEvent);

		event = new Event();
		event.setAllDay(false);
		event.setCity(cities.get("rio"));
		event.setDescription("Disciplina de Sistemas Multi-agentes");
		event.setEventsBoard(null);
		event.setLocation("13o andar/Predio FLPF");
		event.setStart(dateFormat.parse("03032008"));
		event.setStartTime(timeFormat.parse("16:00"));
		event.setEnd(dateFormat.parse("30062008"));
		event.setEndTime(timeFormat.parse("19:00"));
		event.setSubject("SMA 2008-1");
		event.setFrequency(Frequency.TUESDAY);
		event.setOwner(users.get("andrew"));
		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("camila").addEvents(calendarEvent);

		event = new Event();
		event.setAllDay(false);
		event.setCity(cities.get("rio"));
		event.setDescription("Disciplina de Projeto de Sistemas de Software");
		event.setEventsBoard(null);
		event.setLocation("13o andar/Predio FLPF");
		event.setStart(dateFormat.parse("03032008"));
		event.setStartTime(timeFormat.parse("13:00"));
		event.setEnd(dateFormat.parse("30062008"));
		event.setEndTime(timeFormat.parse("16:00"));
		event.setSubject("PSS 2008-1");
		event.setFrequency(Frequency.MONDAY);
		event.setOwner(users.get("ingrid"));
		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("daltro").addEvents(calendarEvent);

		event = new Event();
		event.setAllDay(false);
		event.setCity(cities.get("rio"));
		event
				.setDescription("Seminario do LES no qual alunos de graduacao e pos-graduacao mostram seus trabalhos correntes.");
		event.setEventsBoard(null);
		event.setLocation("13o andar/Predio FLPF");
		event.setStart(dateFormat.parse("01012008"));
		event.setStartTime(timeFormat.parse("13:00"));
		event.setEnd(dateFormat.parse("31072008"));
		event.setEndTime(timeFormat.parse("15:00"));
		event.setSubject("Seminario do LES");
		event.setFrequency(Frequency.FRIDAY);
		event.setOwner(users.get("elder"));
		session.save(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(true);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("suzana").addEvents(calendarEvent);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see SchemaGenerator#createSpecificEntities(org.hibernate.Session)
	 */
	@Override
	public void createSpecificEntities(Session session) throws Exception {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see SchemaGenerator#createUserPreferences(org.hibernate.Session,
	 *      br.pucrio.olis.domain.User)
	 */
	@Override
	public void createUserPreferences(Session session, User user)
			throws Exception {
		user.setPreferences(null);
	}

}
