import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.hibernate.Session;

import br.pucrio.olis.domain.ActivityType;
import br.pucrio.olis.domain.CalendarEvent;
import br.pucrio.olis.domain.Frequency;
import br.pucrio.olis.domain.PlaceType;
import br.pucrio.olis.domain.TravelEvent;
import br.pucrio.olis.domain.TravelPreferences;
import br.pucrio.olis.domain.User;

/*
 * Created on Jun 22, 2008
 */

/**
 * @author Ingrid Nunes
 * 
 */
public class TravelSchemaGenerator extends SchemaGenerator {

	private Map<String, ActivityType> activityTypes;
	private Map<String, PlaceType> placeTypes;

	private void createActivityTypes(Session session) throws Exception {
		activityTypes = new HashMap<String, ActivityType>();

		ActivityType activityType = new ActivityType();
		activityType.setLabel("Abseiling");
		session.save(activityType);
		activityTypes.put("Abseiling", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Horse Riding");
		session.save(activityType);
		activityTypes.put("HorseRiding", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Ballooning");
		session.save(activityType);
		activityTypes.put("Ballooning", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Bird watching");
		session.save(activityType);
		activityTypes.put("BirdWatching", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Bush walking");
		session.save(activityType);
		activityTypes.put("BushWalking", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Canoeing");
		session.save(activityType);
		activityTypes.put("Canoeing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Sailing");
		session.save(activityType);
		activityTypes.put("Sailing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Beach Fishing");
		session.save(activityType);
		activityTypes.put("BeachFishing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Deep Sea");
		session.save(activityType);
		activityTypes.put("DeepSea", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Golf");
		session.save(activityType);
		activityTypes.put("Golf", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Hang Gliding");
		session.save(activityType);
		activityTypes.put("HangGliding", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Jet Boating");
		session.save(activityType);
		activityTypes.put("JetBoating", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Kayaking");
		session.save(activityType);
		activityTypes.put("Kayaking", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Mountain Biking");
		session.save(activityType);
		activityTypes.put("MountainBiking", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Para-Sailing");
		session.save(activityType);
		activityTypes.put("Para-Sailing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Scuba Diving");
		session.save(activityType);
		activityTypes.put("ScubaDiving", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Sea kayaking");
		session.save(activityType);
		activityTypes.put("Seakayaking", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Shopping");
		session.save(activityType);
		activityTypes.put("Shopping", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Sightseeing");
		session.save(activityType);
		activityTypes.put("Sightseeing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Water skiing");
		session.save(activityType);
		activityTypes.put("Waterskiing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Sky diving");
		session.save(activityType);
		activityTypes.put("Sky Diving", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Surfing");
		session.save(activityType);
		activityTypes.put("Surfing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Swimming");
		session.save(activityType);
		activityTypes.put("Swimming", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Tennis");
		session.save(activityType);
		activityTypes.put("Tennis", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Wind Surfing");
		session.save(activityType);
		activityTypes.put("WindSurfing", activityType);
		activityType = new ActivityType();
		activityType.setLabel("Wine Tasting");
		session.save(activityType);
		activityTypes.put("WineTasting", activityType);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see SchemaGenerator#createEvents(org.hibernate.Session)
	 */
	@Override
	public void createEvents(Session session) throws Exception {
		TravelEvent event = null;
		CalendarEvent calendarEvent = null;

		event = new TravelEvent();
		event.setAllDay(true);
		event.setCity(cities.get("sanFrancisco"));
		event
				.setDescription("San Francisco Travel: City of San Francisco California Tourism");
		event.setLocation("Sofitel");
		event.setStart(getDate(1, 0, 0));
		event.setStartTime(null);
		event.setEnd(getDate(3, 23, 59));
		event.setEndTime(null);
		event.setSubject("San Francisco Tour");
		event.setOwner(users.get("ingrid"));

		event.setPlaceType(placeTypes.get("city"));
		event.addActivities(activityTypes.get("Sightseeing"));
		event.addActivities(activityTypes.get("Shopping"));

		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);

		event = new TravelEvent();
		event.setAllDay(false);
		event.setCity(cities.get("estoril"));
		event
				.setDescription("Estoril, cidade portuguesa com praias maravilhosas e um cassino.");
		event.setEventsBoard(null);
		event.setLocation("Hotel Miragem Cascais");
		event.setStart(getDate(12, 8, 0));
		event.setStartTime(null);
		event.setEnd(getDate(16, 16, 30));
		event.setEndTime(null);
		event.setSubject("Estoril 2008");
		event.setOwner(users.get("ingrid"));

		event.setPlaceType(placeTypes.get("beach"));
		event.addActivities(activityTypes.get("Golf"));
		event.addActivities(activityTypes.get("Shopping"));
		event.addActivities(activityTypes.get("Swimming"));

		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);
		getCalendarUserService("andrew").addEvents(calendarEvent);

		event = new TravelEvent();
		event.setAllDay(true);
		event.setCity(cities.get("sanDiego"));
		event
				.setDescription("Knowing San Diego, one beautiful city, with amazing beaches.");
		event.setEventsBoard(null);
		event.setLocation("Casa da Tia Beth");
		event.setStart(getDate(5, 0, 0));
		event.setStartTime(null);
		event.setEnd(getDate(9, 23, 59));
		event.setEndTime(null);
		event.setSubject("San Diego Trip");
		event.setOwner(users.get("ingrid"));

		event.setPlaceType(placeTypes.get("beach"));
		event.addActivities(activityTypes.get("Surfing"));
		event.addActivities(activityTypes.get("Swimming"));
		event.addActivities(activityTypes.get("Canoeing"));
		event.addActivities(activityTypes.get("Sightseeing"));

		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);
		getCalendarUserService("andrew").addEvents(calendarEvent);

		event = new TravelEvent();
		event.setAllDay(false);
		event.setCity(cities.get("rio"));
		event.setDescription("Cidade Maravilhosa, cheia de encantos mil!!!");
		event.setEventsBoard(null);
		event.setLocation("13o andar/Predio FLPF");
		event.setStart(dateFormat.parse("03032008"));
		event.setStartTime(timeFormat.parse("16:00"));
		event.setEnd(dateFormat.parse("30062008"));
		event.setEndTime(timeFormat.parse("19:00"));
		event.setSubject("Rio de Janeiro");
		event.setFrequency(Frequency.TUESDAY);
		event.setOwner(users.get("andrew"));

		event.setPlaceType(placeTypes.get("beach"));
		event.addActivities(activityTypes.get("Surfing"));
		event.addActivities(activityTypes.get("Swimming"));
		event.addActivities(activityTypes.get("Sightseeing"));

		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);
		getCalendarUserService("andrew").addEvents(calendarEvent);
		getCalendarUserService("camila").addEvents(calendarEvent);
		getCalendarUserService("elder").addEvents(calendarEvent);

		event = new TravelEvent();
		event.setAllDay(false);
		event.setCity(cities.get("rio"));
		event
				.setDescription("Porto Alegre - a melhor cidade do Brasil para morar");
		event.setEventsBoard(null);
		event.setLocation("13o andar/Predio FLPF");
		event.setStart(dateFormat.parse("03032008"));
		event.setStartTime(timeFormat.parse("13:00"));
		event.setEnd(dateFormat.parse("30062008"));
		event.setEndTime(timeFormat.parse("16:00"));
		event.setSubject("Porto Alegre  D+!");
		event.setFrequency(Frequency.EVERY_WEEKEND);
		event.setOwner(users.get("ingrid"));

		event.setPlaceType(placeTypes.get("poa"));
		event.addActivities(activityTypes.get("WineTasting"));
		event.addActivities(activityTypes.get("Shopping"));

		session.save(event);
		eventsBoard.addEvents(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(false);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);
		getCalendarUserService("andrew").addEvents(calendarEvent);
		getCalendarUserService("camila").addEvents(calendarEvent);
		getCalendarUserService("elder").addEvents(calendarEvent);

		event = new TravelEvent();
		event.setAllDay(false);
		event.setCity(cities.get("stuttgart"));
		event.setDescription("Cidade do meu coracao.");
		event.setEventsBoard(null);
		event.setLocation("13o andar/Predio FLPF");
		event.setStart(dateFormat.parse("01012008"));
		event.setStartTime(timeFormat.parse("13:00"));
		event.setEnd(dateFormat.parse("31072008"));
		event.setEndTime(timeFormat.parse("15:00"));
		event.setSubject("Stuttgart");
		event.setFrequency(Frequency.FRIDAY);
		event.setOwner(users.get("elder"));

		event.setPlaceType(placeTypes.get("city"));
		event.addActivities(activityTypes.get("Sightseeing"));
		event.addActivities(activityTypes.get("Shopping"));

		session.save(event);

		calendarEvent = new CalendarEvent();
		calendarEvent.setAvailable(true);
		calendarEvent.setEvent(event);
		session.save(calendarEvent);
		getCalendarUserService("ingrid").addEvents(calendarEvent);
		getCalendarUserService("elder").addEvents(calendarEvent);
	}

	private void createPlaceTypes(Session session) throws Exception {
		placeTypes = new HashMap<String, PlaceType>();

		PlaceType placeType = new PlaceType();
		placeType.setLabel("Beach");
		session.save(placeType);
		placeTypes.put("beach", placeType);
		placeType = new PlaceType();
		placeType.setLabel("Mountain");
		session.save(placeType);
		placeTypes.put("mountain", placeType);
		placeType = new PlaceType();
		placeType.setLabel("City");
		session.save(placeType);
		placeTypes.put("city", placeType);
		placeType = new PlaceType();
		placeType.setLabel("Amusement Park");
		session.save(placeType);
		placeTypes.put("park", placeType);
		placeType = new PlaceType();
		placeType.setLabel("Sky Montain");
		session.save(placeType);
		placeTypes.put("sky", placeType);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see SchemaGenerator#createSpecificEntities(org.hibernate.Session)
	 */
	@Override
	public void createSpecificEntities(Session session) throws Exception {
		createPlaceTypes(session);
		createActivityTypes(session);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see SchemaGenerator#createUserPreferences(org.hibernate.Session,
	 *      br.pucrio.olis.domain.User)
	 */
	@Override
	public void createUserPreferences(Session session, User user)
			throws Exception {
		Random random = new Random(System.currentTimeMillis());
		TravelPreferences travelPreferences = new TravelPreferences();

		List<ActivityType> aof = new ArrayList<ActivityType>(activityTypes
				.values());
		for (int i = 0; i < 8; i++) {
			travelPreferences
					.addActivities(aof.get(random.nextInt(aof.size())));
		}

		List<PlaceType> pt = new ArrayList<PlaceType>(placeTypes.values());
		for (int i = 0; i < 2; i++) {
			travelPreferences.addPlaceTypes(pt.get(random.nextInt(pt.size())));
		}

		session.save(travelPreferences);
		user.setPreferences(travelPreferences);
	}

}
