/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.eventremider;

import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.business.BusinessOperation;
import br.pucrio.olis.business.BusinessOperationType;
import br.pucrio.olis.domain.CalendarEvent;
import br.pucrio.olis.domain.CalendarUserService;
import br.pucrio.olis.domain.User;

/**
 * <p>
 * This class represents the plan that handles a business operation message.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class FilterBusinessOperationPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -2515901900032807942L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		BusinessOperation bo = (BusinessOperation) msgEvent.getContent();
		Object param = bo.getParam();
		User user = (User) getBeliefbase().getBelief("myself").getFact();

		if (BusinessOperationType.CREATE.equals(bo.getOperationType())) {
			if (param instanceof CalendarEvent) {
				CalendarEvent calendarEvent = (CalendarEvent) param;
				if (calendarEvent.getParticipants().contains(user)) {
					reescheduleRemindEvent();
				}
			}
		} else if (BusinessOperationType.UPDATE.equals(bo.getOperationType())) {
			if (param instanceof CalendarUserService) {
				CalendarUserService calendarUserService = (CalendarUserService) param;
				if (calendarUserService.getUser().equals(user)) {
					reescheduleRemindEvent();
				}
			}
		}
	}

	private void reescheduleRemindEvent() {
		for (IGoal goal : getGoalbase().getGoals()) {
			log.info("Droping remind event goal.");
			if (goal.getName().startsWith("remind_event")) {
				goal.drop();
			}
		}
		IGoal schedule = createGoal("schedule_next_event");
		dispatchTopLevelGoal(schedule);
	}

}
