/*
 * Created on 13/06/2008
 */
package br.pucrio.olis.agent.eventremider;

import jadex.runtime.GoalFailureException;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;
import br.pucrio.olis.domain.CalendarEvent;
import br.pucrio.olis.domain.CalendarUserService;
import br.pucrio.olis.domain.User;

/**
 * <p>
 * This class represents the plan to schedule the next events to be reminded.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class ScheduleNextEventsPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -3030026574176462812L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		User user = (User) getBeliefbase().getBelief("myself").getFact();
		CalendarUserService calendarUserService = (CalendarUserService) user
				.getService(CalendarUserService.class);
		if (!calendarUserService.getRemindEvents())
			return;

		// Find out what is the next event
		IGoal findEvent = createGoal("query_events");
		dispatchSubgoalAndWait(findEvent);
		CalendarEvent nextEvent = (CalendarEvent) findEvent.getParameter(
				"result").getValue();

		if (nextEvent != null) {
			try {
				IGoal remind = createGoal("remind_event");
				remind.getParameter("event").setValue(nextEvent);
				dispatchTopLevelGoal(remind);
			} catch (GoalFailureException e) {
				e.printStackTrace();
			}
		}
	}

}
