/*
 * Created on Jun 15, 2008
 */
package br.pucrio.olis.agent.eventsuggestion;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.business.BusinessException;
import br.pucrio.olis.business.ServiceLocator;
import br.pucrio.olis.business.service.UserService;
import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.EventsAnnouncementUserService;
import br.pucrio.olis.domain.User;

/**
 * @author Ingrid Nunes
 * 
 */
public class AnnounceEventPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 8451556899881362601L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		try {
			User myself = (User) getBeliefbase().getBelief("myself").getFact();
			Event event = (Event) getParameter("event").getValue();
			UserService userService = (UserService) ServiceLocator
					.getInstance().getService(UserService.SERVICE_NAME);
			List<User> users = userService.loadAll();
			for (User user : users) {
				if (user.equals(myself))
					continue;
				EventsAnnouncementUserService eventsAnnouncementUserService = (EventsAnnouncementUserService) user
						.getService(EventsAnnouncementUserService.class);
				if (!eventsAnnouncementUserService.getSuggestEvents())
					continue;

				log.info("Checking interest from user " + user.getFullName());
				IGoal search = createGoal("check_interest");
				search.getParameter("user").setValue(user);
				search.getParameter("event").setValue(event);
				dispatchTopLevelGoal(search);
			}
		} catch (BusinessException e) {
			log.error(e);
			e.printStackTrace();
		}
	}
}
