/*
 * Created on Jun 15, 2008
 */
package br.pucrio.olis.agent.eventsuggestion;

import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.business.BusinessOperation;
import br.pucrio.olis.business.BusinessOperationType;
import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.User;

/**
 * <p>
 * This class represents the plan that handles a business operation message.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class FilterBusinessOperationPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -2515901900032807942L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		BusinessOperation bo = (BusinessOperation) msgEvent.getContent();
		if (BusinessOperationType.CREATE.equals(bo.getOperationType())) {
			Object param = bo.getParam();
			if (param instanceof Event) {
				Event event = (Event) bo.getParam();
				User user = (User) getBeliefbase().getBelief("myself")
						.getFact();
				if (event.getOwner().equals(user)) {
					log.info("New event inserted by " + user.getFullName()
							+ "! Adding goal to announce the event.");
					IGoal announce = createGoal("announce_event");
					announce.getParameter("event").setValue(event);
					dispatchTopLevelGoal(announce);
				}
			}
		}
	}

}
