/*
 * Created on 16/06/2008
 */
package br.pucrio.olis.agent.eventsuggestion;

import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.fipa.SFipa;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.business.ServiceLocator;
import br.pucrio.olis.business.service.UserService;
import br.pucrio.olis.domain.EventSuggestionNotification;
import br.pucrio.olis.domain.User;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class ReceiveInterestAnswerPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -8949044130640997999L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		IMessageEvent msg = (IMessageEvent) getInitialEvent();
		EventInterestAnswer eventInterestAnswer = (EventInterestAnswer) msg
				.getContent();

		if (SFipa.CONFIRM.equals(msg.getParameter(SFipa.PERFORMATIVE)
				.getValue())) {
			AgentIdentifier aid = (AgentIdentifier) msg.getParameter("sender")
					.getValue();

			log.info("Received a confirm answer (Event: "
					+ eventInterestAnswer.getEvent().getSubject() + "; User: "
					+ aid + ").");
			Long value = (Long) getBeliefbase().getBelief("accepted_counter")
					.getFact();
			getBeliefbase().getBelief("accepted_counter").setFact(
					new Long(value + 1));

			try {
				User user = new User();
				user.setId(new Long(aid.getLocalName().split("_")[1]));
				EventSuggestionNotification eventSuggestionNotification = new EventSuggestionNotification();
				eventSuggestionNotification.setEvent(eventInterestAnswer
						.getEvent());
				UserService service = (UserService) ServiceLocator
						.getInstance().getService(UserService.SERVICE_NAME);
				service.addNotification(user, eventSuggestionNotification);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		} else if (SFipa.DISCONFIRM.equals(msg.getParameter(SFipa.PERFORMATIVE)
				.getValue())) {
			log.info("Received a disconfirm answer (Event: "
					+ eventInterestAnswer.getEvent().getSubject() + "; User: "
					+ msg.getParameter("sender").getValue() + ").");

			Long value = (Long) getBeliefbase().getBelief("refused_counter")
					.getFact();
			getBeliefbase().getBelief("refused_counter").setFact(
					new Long(value + 1));

		}

		log.info("Reason:");
		for (String r : eventInterestAnswer.getReason()) {
			log.info("* " + r);
		}
	}
}
