/*
 * Created on 16/06/2008
 */
package br.pucrio.olis.agent.eventsuggestion;

import jadex.adapter.fipa.SFipa;
import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;
import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.Frequency;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class ReceiveInterestQueryPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -732778654811970369L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		EventInterestQuery eventInterestQuery = (EventInterestQuery) msgEvent
				.getContent();
		Event event = eventInterestQuery.getEvent();

		EventInterestAnswer eventInterestAnswer = new EventInterestAnswer();
		eventInterestAnswer.setEvent(event);

		boolean available = true;
		if (Frequency.ONCE.equals(event.getFrequency())) {
			IGoal availability = createGoal("check_availability");
			availability.getParameter("start").setValue(event.getStart());
			availability.getParameter("end").setValue(event.getEnd());
			dispatchSubgoalAndWait(availability);

			if (!(Boolean) availability.getParameter("result").getValue()) {
				available = false;
				eventInterestAnswer
						.addReason("Not available on the event date.");
			}
		}

		IGoal interest = createGoal("check_interest");
		interest.getParameter("event").setValue(event);
		dispatchSubgoalAndWait(interest);

		for (Object r : interest.getParameterSet("reason").getValues()) {
			eventInterestAnswer.addReason((String) r);
		}

		double interestRate = (Double) interest.getParameter("result")
				.getValue();

		double result = ((3 * (available ? 1.0 : 0.0)) + (7 * interestRate)) / 10;

		IMessageEvent msg = msgEvent.createReply("event_interest_answer",
				eventInterestAnswer);
		if (result > 0.6) {
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.CONFIRM);
		} else {
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.DISCONFIRM);
		}

		sendMessage(msg);
	}

}
