/*
 * Created on Jun 19, 2008
 */
package br.pucrio.olis.agent.eventsuggestion.academicevent;

import jadex.runtime.Plan;
import br.pucrio.olis.domain.AcademicEvent;
import br.pucrio.olis.domain.AcademicPreferences;
import br.pucrio.olis.domain.AreaOfInterest;

/**
 * @author Ingrid Nunes
 * 
 */
public class AreaOfInterestPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 5470683285158822991L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		AcademicPreferences preferences = (AcademicPreferences) getBeliefbase()
				.getBelief("preferences").getFact();
		AcademicEvent event = (AcademicEvent) getParameter("event").getValue();

		if (preferences.getAreasOfInterest().isEmpty()
				|| event.getAreasOfInterest().isEmpty()) {
			getParameter("result").setValue(0.5);
		} else {
			int count = 0;
			for (AreaOfInterest areaOfInterest : event.getAreasOfInterest()) {
				if (preferences.getAreasOfInterest().contains(areaOfInterest)) {
					count++;
				}
			}

			getParameter("result").setValue(
					((double) count) / event.getAreasOfInterest().size());
		}
	}

}
