/*
 * Created on Jun 15, 2008
 */
package br.pucrio.olis.agent.eventsuggestion.academicevent;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.domain.AcademicEvent;

/**
 * @author Ingrid Nunes
 * 
 */
public class CheckAcademicEventPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -3131315005903622626L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		AcademicEvent event = (AcademicEvent) getParameter("event").getValue();

		IGoal location = createGoal("check_location");
		location.getParameter("event").setValue(event);
		dispatchSubgoalAndWait(location);
		double resultLocation = (Double) location.getParameter("result")
				.getValue();
		if (resultLocation < 0.4) {
			getParameterSet("reason").addValue(
					"Not interested in foreign events.");
		}

		IGoal areaofinterest = createGoal("check_areasofinterest");
		areaofinterest.getParameter("event").setValue(event);
		dispatchSubgoalAndWait(areaofinterest);
		double resultAreaofinterest = (Double) areaofinterest.getParameter(
				"result").getValue();
		if (resultAreaofinterest < 0.4) {
			getParameterSet("reason").addValue(
					"Few interesting areas of interest.");
		}

		IGoal eventType = createGoal("check_eventtype");
		eventType.getParameter("event").setValue(event);
		dispatchSubgoalAndWait(eventType);
		double resultEventType = (Double) eventType.getParameter("result")
				.getValue();
		if (resultEventType < 0.4) {
			getParameterSet("reason").addValue(
					"Not interested in this event type: "
							+ event.getEventType() + ".");
		}

		double result = (resultLocation + 2 * resultAreaofinterest + resultEventType) / 4;
		log.info("Interest rate: " + result);
		getParameter("result").setValue(result);
	}

}
