/*
 * Created on Jun 21, 2008
 */
package br.pucrio.olis.agent.eventsuggestion.travelevent;

import jadex.runtime.Plan;
import br.pucrio.olis.domain.ActivityType;
import br.pucrio.olis.domain.TravelEvent;
import br.pucrio.olis.domain.TravelPreferences;

/**
 * @author Ingrid Nunes
 * 
 */
public class ActivityPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 5470683285158822991L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		TravelPreferences preferences = (TravelPreferences) getBeliefbase()
				.getBelief("preferences").getFact();
		TravelEvent event = (TravelEvent) getParameter("event").getValue();

		if (preferences.getActivities().isEmpty()
				|| event.getActivities().isEmpty()) {
			getParameter("result").setValue(0.5);
		} else {
			int count = 0;
			for (ActivityType activityType : event.getActivities()) {
				if (preferences.getActivities().contains(activityType)) {
					count++;
				}
			}

			getParameter("result").setValue(
					((double) count) / event.getActivities().size());
		}
	}

}
