/*
 * Created on 18/06/2008
 */
package br.pucrio.olis.agent.eventsuggestion.travelevent;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.domain.Frequency;
import br.pucrio.olis.domain.TravelEvent;

/**
 * @author Ingrid Nunes
 * 
 */
public class CheckTravelEventPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -3131315005903622626L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		TravelEvent event = (TravelEvent) getParameter("event").getValue();

		IGoal activity = createGoal("check_activities");
		activity.getParameter("event").setValue(event);
		dispatchSubgoalAndWait(activity);
		double resultActivity = (Double) activity.getParameter("result")
				.getValue();
		if (resultActivity < 0.4) {
			getParameterSet("reason").addValue("Few interesting activities.");
		}

		IGoal placeType = createGoal("check_placetype");
		placeType.getParameter("event").setValue(event);
		dispatchSubgoalAndWait(placeType);
		double resultPlaceType = (Double) placeType.getParameter("result")
				.getValue();
		if (resultPlaceType < 0.4) {
			getParameterSet("reason").addValue(
					"Not interested in this place type: "
							+ event.getPlaceType().getLabel() + ".");
		}

		double resultWeather = -1;
		if (Frequency.ONCE.equals(event.getFrequency())) {
			IGoal weather = createGoal("check_weather_good");
			weather.getParameter("event").setValue(event);
			dispatchSubgoalAndWait(weather);
			resultWeather = (Double) weather.getParameter("result").getValue();
			if (resultWeather < 0) {
				log.info("Don't know about the weather.");
			} else if (resultWeather < 0.3) {
				getParameterSet("reason").addValue(
						"Weather is not going to be good.");
			}
		}

		double result = 0;
		if (resultWeather < 0) {
			result = (2 * resultActivity + resultPlaceType) / 3;
		} else {
			result = (3 * resultActivity + 2 * resultPlaceType + resultWeather) / 6;
		}
		log.info("Interest rate: " + result);
		getParameter("result").setValue(result);
	}

}
