/*
 * Created on Jun 21, 2008
 */
package br.pucrio.olis.agent.eventsuggestion.travelevent;

import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.fipa.SFipa;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import java.util.Date;

import br.pucrio.olis.agent.weather.ForecastRequest;
import br.pucrio.olis.agent.weather.ForecastResponse;
import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.DegreeUnit;

/**
 * @author Ingrid Nunes
 * 
 */
public class ForecastPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -3799138352713764420L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		City city = (City) getParameter("city").getValue();
		Date date = (Date) getParameter("date").getValue();

		IMessageEvent msg = createMessageEvent("forecast");
		msg.getParameterSet(SFipa.RECEIVERS).addValue(
				new AgentIdentifier("weather", true));
		ForecastRequest forecastRequest = new ForecastRequest();
		forecastRequest.setCity(city);
		forecastRequest.setDate(date);
		forecastRequest.setDegreeUnit(DegreeUnit.CELSIUS);
		msg.setContent(forecastRequest);
		getWaitqueue().addReply(msg);
		sendMessage(msg);

		IMessageEvent reply = waitForReply(msg);
		if (SFipa.FAILURE.equals(reply.getParameter(SFipa.PERFORMATIVE)
				.getValue())) {
			getParameter("result").setValue(null);
		} else {
			ForecastResponse forecastResponse = (ForecastResponse) reply
					.getContent();
			getParameter("result").setValue(forecastResponse.getDayForecast());
		}
	}

}
