/*
 * Created on Jun 21, 2008
 */
package br.pucrio.olis.agent.eventsuggestion.travelevent;

/**
 * @author Ingrid Nunes
 * 
 */
public class Temperature {

	public enum Classification {
		COLD, COOL, HOT, VERY_COLD, VERY_HOT, WARM
	}

	private Double max;
	private Double min;

	public Temperature(Double min, Double max) {
		this.min = min;
		this.max = max;
	}

	public Temperature(Integer min, Integer max) {
		this.min = min == null ? null : new Double(min);
		this.max = max == null ? null : new Double(max);
	}

	public Classification getClassification() {
		double mean = 0;
		if (min == null)
			mean = max;
		else if (max == null)
			mean = min;
		else
			mean = (min + max) / 2;
		if (mean < 0) {
			return Classification.VERY_COLD;
		} else if (mean < 9) {
			return Classification.COLD;
		} else if (mean < 15) {
			return Classification.COOL;
		} else if (mean < 25) {
			return Classification.WARM;
		} else if (mean < 33) {
			return Classification.HOT;
		} else {
			return Classification.VERY_HOT;
		}
	}

	public Double getMax() {
		return max;
	}

	public Double getMin() {
		return min;
	}

}
