/*
 * Created on Jun 21, 2008
 */
package br.pucrio.olis.agent.eventsuggestion.travelevent.weather;

import br.pucrio.olis.agent.eventsuggestion.travelevent.Rain;
import br.pucrio.olis.agent.eventsuggestion.travelevent.Temperature;
import br.pucrio.olis.agent.eventsuggestion.travelevent.Wind;

/**
 * @author Ingrid Nunes
 * 
 */
public class SkyMountainCalculator extends WeatherRateCalculator {

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.agent.eventsuggestion.travelevent.weather.WeatherRateCalculator#getClassification(br.pucrio.olis.agent.eventsuggestion.travelevent.Rain)
	 */
	@Override
	protected Classification getClassification(Rain rain) {
		switch (rain.getClassification()) {
		case ALMOST_NO:
			return Classification.VERY_GOOD;
		case UNPROBABLE:
			return Classification.VERY_GOOD;
		case MAYBE:
			return Classification.GOOD;
		case PROBABLE:
			return Classification.GOOD;
		case ALMOST_YES:
			return Classification.OK;
		}
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.agent.eventsuggestion.travelevent.weather.WeatherRateCalculator#getClassification(br.pucrio.olis.agent.eventsuggestion.travelevent.Temperature)
	 */
	@Override
	protected Classification getClassification(Temperature temperature) {
		switch (temperature.getClassification()) {
		case VERY_COLD:
			return Classification.GOOD;
		case COLD:
			return Classification.VERY_GOOD;
		case COOL:
			return Classification.NOT_SO_GOOD;
		case WARM:
			return Classification.NOT_SO_BAD;
		case HOT:
			return Classification.BAD;
		case VERY_HOT:
			return Classification.VERY_BAD;
		}
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.agent.eventsuggestion.travelevent.weather.WeatherRateCalculator#getClassification(br.pucrio.olis.agent.eventsuggestion.travelevent.Wind)
	 */
	@Override
	protected Classification getClassification(Wind wind) {
		switch (wind.getClassification()) {
		case CALM:
			return Classification.VERY_GOOD;
		case BREEZE:
			return Classification.GOOD;
		case GALE:
			return Classification.BAD;
		case STORM:
			return Classification.VERY_BAD;
		case HURRICANE:
			return Classification.VERY_BAD;
		}
		return null;
	}

}
