/*
 * Created on 11/06/2008
 */
package br.pucrio.olis.agent.manager;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.business.BusinessOperation;
import br.pucrio.olis.business.BusinessOperationType;
import br.pucrio.olis.domain.User;

/**
 * <p>
 * This class represents the plan that handles a business operation message.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class FilterBusinessOperationPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 4060657206059702366L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		BusinessOperation bo = (BusinessOperation) getParameter(
				"businessoperation").getValue();
		if (BusinessOperationType.CREATE.equals(bo.getOperationType())
				&& (bo.getParam() instanceof User)) {
			log.info("New user inserted! Adding goal to start new user agent.");
			IGoal start = createGoal("start_new_agent");
			start.getParameter("userId").setValue(
					((User) bo.getParam()).getId());
			dispatchTopLevelGoal(start);
		}
	}

}
