/*
 * Created on Jun 10, 2008
 */
package br.pucrio.olis.agent.manager;

import jadex.planlib.StartAgentInfo;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <p>
 * This class represents the plan that start a new user agent.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class StartNewAgentPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 5893828282723449783L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void body() {
		Long userId = (Long) getParameter("userId").getValue();
		Map args = new HashMap<String, Object>();
		args.put("myId", userId);
		StartAgentInfo startAgentInfo = new StartAgentInfo(
				"br.pucrio.olis.agent.user.User", "user_" + userId, 0, args);

		IGoal start = createGoal("start_agents");
		start.getParameterSet("agentinfos").removeValues();
		start.getParameterSet("agentinfos").addValue(startAgentInfo);
		
		log.info("Dispatching subgoal to start new agent");
		dispatchSubgoalAndWait(start);
		getBeliefbase().getBeliefSet("startedagents").addFacts(
				start.getParameterSet("agentidentifiers").getValues());

	}

}
