/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.scheduler;

import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.fipa.SFipa;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.domain.User;

/**
 * @author Ingrid Nunes
 * 
 */
public class CheckTimeOkPlan extends Plan {

	private static final long serialVersionUID = 3347023306541898112L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		Date start = (Date) getParameter("start").getValue();
		Date end = (Date) getParameter("end").getValue();

		log.info("Check if the event time is ok. Start: " + start + " End: "
				+ end);

		for (Object value : getParameterSet("participants").getValues()) {
			User participant = (User) value;

			IMessageEvent msg = createMessageEvent("query_availability");
			msg.getParameterSet(SFipa.RECEIVERS).addValue(
					new AgentIdentifier("user_" + participant.getId(), true));
			AvailabilityQuery availabilityQuery = new AvailabilityQuery();
			availabilityQuery.setStart(start);
			availabilityQuery.setEnd(end);
			msg.setContent(availabilityQuery);
			getWaitqueue().addReply(msg);
			sendMessage(msg);

			IMessageEvent reply = waitForReply(msg);
			if (SFipa.DISCONFIRM.equals(reply.getParameter(SFipa.PERFORMATIVE)
					.getValue())) {
				log.info(participant.getFullName()
						+ " is not available in the event date");
				getParameter("user").setValue(participant);
				getParameter("result").setValue(Boolean.FALSE);
				return;
			}
		}

		log.info("All the participants are available in the event date");
		getParameter("user").setValue(null);
		getParameter("result").setValue(Boolean.TRUE);
	}

}
