/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.scheduler;

import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.business.BusinessOperation;
import br.pucrio.olis.business.BusinessOperationType;
import br.pucrio.olis.domain.CalendarEvent;
import br.pucrio.olis.domain.Frequency;
import br.pucrio.olis.domain.User;

/**
 * <p>
 * This class represents the plan that handles a business operation message.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class FilterBusinessOperationPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -2515901900032807942L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		BusinessOperation bo = (BusinessOperation) msgEvent.getContent();
		if (BusinessOperationType.CREATE.equals(bo.getOperationType())) {
			Object param = bo.getParam();
			if (param instanceof CalendarEvent) {
				CalendarEvent event = (CalendarEvent) bo.getParam();
				User user = (User) getBeliefbase().getBelief("myself")
						.getFact();
				if (Frequency.ONCE.equals(event.getEvent().getFrequency())
						&& !event.getAvailable()
						&& user.equals(event.getOwner())) {
					log.info("New calendar event inserted by "
							+ user.getFullName() + "! Adding goal to check if "
							+ "the time is ok for the event.");
					IGoal schedule = createGoal("schedule_event");
					schedule.getParameter("event").setValue(event);
					dispatchTopLevelGoal(schedule);
				}
			}
		}
	}

}
