/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.scheduler;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import java.util.Date;

/**
 * @author Ingrid Nunes
 * 
 */
public class QueryAlternativeTimePlan extends Plan {

	private static final long ONE_DAY = 24 * 60 * 60 * 1000L;
	private static final long serialVersionUID = 3347023306541898112L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		Date start = (Date) getParameter("start").getValue();
		Long duration = (Long) getParameter("duration").getValue();

		// FIXME Make a more intelligent algorithm 
		Boolean available = Boolean.FALSE;
		Date alternativeTime = new Date(start.getTime() + ONE_DAY);
		while (!available) {
			IGoal availability = createGoal("query_availability");
			availability.getParameter("start").setValue(alternativeTime);
			availability.getParameter("end").setValue(
					new Date(alternativeTime.getTime() + duration));
			dispatchSubgoalAndWait(availability);
			available = (Boolean) availability.getParameter("result")
					.getValue();
			if (!available) {
				alternativeTime = new Date(alternativeTime.getTime() + ONE_DAY);
			}
		}

		getParameter("result").setValue(alternativeTime);
	}

}
