/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.scheduler;

import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import java.util.Date;


/**
 * @author Ingrid Nunes
 * 
 */
public class ReceiveAlternativeTimeQueryPlan extends Plan {

	private static final long serialVersionUID = 3347023306541898112L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		AlternativeTimeQuery alternativeTimeQuery = (AlternativeTimeQuery) msgEvent
				.getContent();

		IGoal alternativeTime = createGoal("query_alternative_time");
		alternativeTime.getParameter("start").setValue(
				alternativeTimeQuery.getStart());
		alternativeTime.getParameter("duration").setValue(
				alternativeTimeQuery.getDuration());
		dispatchSubgoalAndWait(alternativeTime);
		Date time = (Date) alternativeTime.getParameter("result").getValue();

		AlternativeTimeAnswer alternativeTimeAnswer = new AlternativeTimeAnswer();
		alternativeTimeAnswer.setAlternativeTime(time);
		IMessageEvent msg = msgEvent.createReply("answer_alternative_time",
				alternativeTimeAnswer);

		sendMessage(msg);
	}

}
