/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.scheduler;

import jadex.adapter.fipa.SFipa;
import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

/**
 * @author Ingrid Nunes
 * 
 */
public class ReceiveAvailabilityQueryPlan extends Plan {

	private static final long serialVersionUID = 3347023306541898112L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		AvailabilityQuery availabilityQuery = (AvailabilityQuery) msgEvent
				.getContent();

		IGoal availability = createGoal("query_availability");
		availability.getParameter("start").setValue(
				availabilityQuery.getStart());
		availability.getParameter("end").setValue(availabilityQuery.getEnd());
		dispatchSubgoalAndWait(availability);
		Boolean available = (Boolean) availability.getParameter("result")
				.getValue();

		AvailabilityAnswer availabilityAnswer = new AvailabilityAnswer();
		availabilityAnswer.setAvailable(available);
		IMessageEvent msg = msgEvent.createReply("answer_availability",
				availabilityAnswer);

		if (available) {
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.CONFIRM);
		} else {
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.DISCONFIRM);
		}

		sendMessage(msg);
	}

}
