/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.agent.scheduler;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;
import br.pucrio.olis.domain.CalendarEvent;
import br.pucrio.olis.domain.User;

/**
 * @author Ingrid Nunes
 * 
 */
public class ScheduleEventPlan extends Plan {

	private static final long serialVersionUID = 3347023306541898112L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		CalendarEvent calendarEvent = (CalendarEvent) getParameter("event")
				.getValue();
		// Only myself
		if (calendarEvent.getParticipants().size() == 1)
			return;

		User user = (User) getBeliefbase().getBelief("myself").getFact();

		IGoal timeOK = createGoal("check_time_ok");
		timeOK.getParameter("start").setValue(
				calendarEvent.getEvent().getStart());
		timeOK.getParameter("end").setValue(calendarEvent.getEvent().getEnd());
		for (User participant : calendarEvent.getParticipants()) {
			// The user who inserted the event do not have to be checked
			if (user.equals(participant))
				continue;
			timeOK.getParameterSet("participants").addValue(participant);
		}
		dispatchSubgoalAndWait(timeOK);

		Boolean result = (Boolean) timeOK.getParameter("result").getValue();
		if (!result) {
			IGoal reschedule = createGoal("reschedule_event");
			reschedule.getParameter("event").setValue(calendarEvent);
			reschedule.getParameter("user").setValue(
					(User) timeOK.getParameter("user").getValue());
			dispatchTopLevelGoal(reschedule);
			return;
		}
	}

}
