/*
 * Created on 10/06/2008
 */
package br.pucrio.olis.agent.util;

import jadex.adapter.fipa.AgentDescription;
import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.fipa.SearchConstraints;
import jadex.adapter.fipa.ServiceDescription;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import java.util.Random;

/**
 * <p>
 * This class represents the plan that search in the directory facilitator the
 * agent that provides that environment service.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class SearchEnvironmentPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 5280315555067070038L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		// Create a service description to search for.
		ServiceDescription sd = new ServiceDescription();
		sd.setType("environment");
		AgentDescription dfadesc = new AgentDescription();
		dfadesc.addService(sd);
		SearchConstraints sc = new SearchConstraints();
		sc.setMaxResults(-1);

		// Use a subgoal to search for a dealer-agent
		IGoal ft = createGoal("df_search");
		ft.getParameter("description").setValue(dfadesc);
		ft.getParameter("constraints").setValue(sc);
		dispatchSubgoalAndWait(ft);

		AgentDescription[] result = (AgentDescription[]) ft.getParameterSet(
				"result").getValues();

		if (result == null || result.length == 0) {
			fail();
		} else {
			// at least one matching AgentDescription found,
			AgentIdentifier dealer = result[new Random().nextInt(result.length)]
					.getName();
			getBeliefbase().getBelief("environment").setFact(dealer);
		}

	}

	/**
	 * Called when something went wrong (e.g. timeout).
	 */
	public void failed() {
		// Remove environment fact.
		getBeliefbase().getBelief("environment").setFact(null);
	}

}
