/*
 * Created on 19/06/2008
 */
package br.pucrio.olis.agent.weather;

import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.restlet.Client;
import org.restlet.data.Response;

import br.pucrio.olis.agent.weather.service.WeatherRequest;
import br.pucrio.olis.agent.weather.service.WeatherResponse;
import br.pucrio.olis.domain.DegreeUnit;
import br.pucrio.olis.domain.weather.LocationSimple;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class ConsultWeatherPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -3946074660836209167L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		try {
			Client client = (Client) getBeliefbase().getBelief("client")
					.getFact();
			LocationSimple location = (LocationSimple) getParameter("location")
					.getValue();
			Boolean currentConditions = (Boolean) getParameter(
					"currentConditions").getValue();
			Integer dayForecasts = (Integer) getParameter("dayForecasts")
					.getValue();
			DegreeUnit degreeUnit = (DegreeUnit) getParameter("degreeUnit")
					.getValue();

			WeatherRequest weatherRequest = new WeatherRequest(location.getId());
			weatherRequest.setCurrentConditions(currentConditions);
			weatherRequest.setDayForecasts(dayForecasts);
			weatherRequest.setDegreeUnit(degreeUnit);
			log.info(weatherRequest.getURL());
			Response response = client.get(weatherRequest.getURL());

			WeatherResponse weatherResponse = new WeatherResponse(response
					.getEntityAsDom());
			getParameter("result").setValue(weatherResponse.getWeather());
		} catch (Exception e) {
			log.warn(e);
			getParameter("result").setValue(null);
		}
	}

}
