/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.agent.weather;

import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.restlet.Client;
import org.restlet.data.Response;

import br.pucrio.olis.agent.weather.service.SearchRequest;
import br.pucrio.olis.agent.weather.service.SearchResponse;
import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.weather.LocationSimple;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class DiscoverLocationPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -2295964915801804251L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		Client client = (Client) getBeliefbase().getBelief("client").getFact();
		City city = (City) getParameter("city").getValue();

		String where = city.getName();
		if (city.getCountry() != null) {
			where += ", " + city.getCountry().getName();
		}

		SearchRequest searchRequest = new SearchRequest(where);
		log.info(searchRequest.getURL());
		Response response = client.get(searchRequest.getURL());

		SearchResponse searchResponse = new SearchResponse(response
				.getEntityAsDom());
		log.info(searchResponse.getLocations().size() + " locations found.");
		for (LocationSimple locationSimple : searchResponse.getLocations()) {
			getParameterSet("result").addValue(locationSimple);
		}

	}

}
