/*
 * Created on Jun 21, 2008
 */
package br.pucrio.olis.agent.weather;

import jadex.adapter.fipa.SFipa;
import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;

import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.domain.weather.Weather;

/**
 * @author Ingrid Nunes
 * 
 */
public class ForecastRequestPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -743594929751071915L;
	public static final long MIL_PER_DAY = 1000 * 60 * 60 * 24;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		ForecastRequest forecastRequest = (ForecastRequest) msgEvent
				.getContent();

		Weather weather = null;
		Date now = new Date();
		Date date = forecastRequest.getDate();
		int daysForecast = (int) Math.round((date.getTime() - now.getTime())
				/ MIL_PER_DAY);

		log.info("Event is going to happen " + daysForecast + " after today.");

		if (daysForecast > 0 || daysForecast < 6) {
			IGoal getWeather = createGoal("get_weather");
			getWeather.getParameter("city").setValue(forecastRequest.getCity());
			getWeather.getParameter("currentConditions")
					.setValue(Boolean.FALSE);
			getWeather.getParameter("dayForecasts").setValue(
					new Integer(daysForecast + 1));
			getWeather.getParameter("degreeUnit").setValue(
					forecastRequest.getDegreeUnit());
			dispatchSubgoalAndWait(getWeather);

			weather = (Weather) getWeather.getParameter("weather").getValue();
		}

		if (weather == null) {
			ForecastResponse forecastResponse = new ForecastResponse();
			IMessageEvent msg = msgEvent.createReply("forecast_response",
					forecastResponse);
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.FAILURE);
			sendMessage(msg);
		} else {
			ForecastResponse forecastResponse = new ForecastResponse();
			forecastResponse.setDayForecast(weather.getDayForecastList().get(
					daysForecast));
			forecastResponse.setHead(weather.getHead());
			forecastResponse.setLocation(weather.getLocation());
			IMessageEvent msg = msgEvent.createReply("forecast_response",
					forecastResponse);
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.INFORM);
			sendMessage(msg);
		}
	}

}
