/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.agent.weather;

import jadex.runtime.IGoal;
import jadex.runtime.Plan;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.DegreeUnit;
import br.pucrio.olis.domain.weather.LocationSimple;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class GetWeatherPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -743594929751071915L;

	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		City city = (City) getParameter("city").getValue();
		Boolean currentConditions = (Boolean) getParameter("currentConditions")
				.getValue();
		Integer dayForecasts = (Integer) getParameter("dayForecasts")
				.getValue();
		DegreeUnit degreeUnit = (DegreeUnit) getParameter("degreeUnit")
				.getValue();

		IGoal locations = createGoal("discover_location");
		locations.getParameter("city").setValue(city);
		dispatchSubgoalAndWait(locations);

		if (locations.getParameterSet("result").size() == 0) {
			getParameter("weather").setValue(null);
			return;
		}
		if (locations.getParameterSet("result").size() > 0) {
			log.warn("More then one location, choosing one of them.");
		}
		LocationSimple location = (LocationSimple) locations.getParameterSet(
				"result").getValues()[0];
		log.info(location);

		IGoal weather = createGoal("consult_weather");
		weather.getParameter("location").setValue(location);
		weather.getParameter("currentConditions").setValue(currentConditions);
		weather.getParameter("dayForecasts").setValue(dayForecasts);
		weather.getParameter("degreeUnit").setValue(degreeUnit);
		dispatchSubgoalAndWait(weather);

		getParameter("weather").setValue(
				weather.getParameter("result").getValue());
	}

}
