/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.agent.weather;

import jade.content.Predicate;

import java.io.Serializable;

import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.DegreeUnit;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class WeatherRequest implements Serializable, Predicate {

	private static final long serialVersionUID = -6237472539025921604L;

	private City city;
	private boolean currentConditions;
	private int dayForecasts;
	private DegreeUnit degreeUnit;

	public WeatherRequest() {
	}

	public WeatherRequest(City city) {
		this.city = city;
		this.currentConditions = true;
		this.dayForecasts = 5;
		this.degreeUnit = DegreeUnit.CELSIUS;
	}

	public City getCity() {
		return city;
	}

	public int getDayForecasts() {
		return dayForecasts;
	}

	public DegreeUnit getDegreeUnit() {
		return degreeUnit;
	}

	public boolean getCurrentConditions() {
		return currentConditions;
	}

	public void setCity(City city) {
		this.city = city;
	}

	public void setCurrentConditions(boolean currentConditions) {
		this.currentConditions = currentConditions;
	}

	public void setDayForecasts(int dayForecasts) {
		this.dayForecasts = dayForecasts;
	}

	public void setDegreeUnit(DegreeUnit degreeUnit) {
		this.degreeUnit = degreeUnit;
	}

}
