/*
 * Created on 19/06/2008
 */
package br.pucrio.olis.agent.weather;

import jadex.adapter.fipa.SFipa;
import jadex.runtime.IGoal;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;
import br.pucrio.olis.domain.weather.Weather;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class WeatherRequestPlan extends Plan {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -743594929751071915L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jadex.runtime.Plan#body()
	 */
	@Override
	public void body() {
		IMessageEvent msgEvent = (IMessageEvent) getInitialEvent();
		WeatherRequest weatherRequest = (WeatherRequest) msgEvent.getContent();

		IGoal getWeather = createGoal("get_weather");
		getWeather.getParameter("city").setValue(weatherRequest.getCity());
		getWeather.getParameter("currentConditions").setValue(
				weatherRequest.getCurrentConditions());
		getWeather.getParameter("dayForecasts").setValue(
				weatherRequest.getDayForecasts());
		getWeather.getParameter("degreeUnit").setValue(
				weatherRequest.getDegreeUnit());
		dispatchSubgoalAndWait(getWeather);

		Weather weather = (Weather) getWeather.getParameter("weather")
				.getValue();

		WeatherResponse weatherResponse = new WeatherResponse();
		weatherResponse.setWeather(weather);
		IMessageEvent msg = msgEvent.createReply("weather_response",
				weatherResponse);
		if (weather == null) {
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.FAILURE);
		} else {
			msg.getParameter(SFipa.PERFORMATIVE).setValue(SFipa.INFORM);
		}
		sendMessage(msg);
	}

}
