/*
 * Created on Jun 19, 2008
 */
package br.pucrio.olis.agent.weather.service;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.restlet.resource.DomRepresentation;
import org.w3c.dom.Node;

import br.pucrio.olis.domain.weather.LocationSimple;

/**
 * @author Ingrid Nunes
 * 
 */
public class SearchResponse implements Serializable {

	private static final long serialVersionUID = 7869251648104791948L;

	public List<LocationSimple> locations;

	public SearchResponse() {
		locations = new ArrayList<LocationSimple>();
	}

	public SearchResponse(DomRepresentation document) {
		this();
		String expr = "/search/loc";
		for (Node node : document.getNodes(expr)) {
			this.addLocations(new LocationSimple(node));
		}
	}

	public void addLocations(LocationSimple location) {
		this.locations.add(location);
	}

	public Iterator<LocationSimple> getAllLocations() {
		return locations.iterator();
	}

	public List<LocationSimple> getLocations() {
		return locations;
	}

	public void setLocations(List<LocationSimple> locations) {
		this.locations = locations;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		for (LocationSimple location : locations) {
			sb.append(location.toString()).append("\n");
		}
		return sb.toString();
	}

}
