/*
 * Created on Jun 19, 2008
 */
package br.pucrio.olis.agent.weather.service;

import java.io.Serializable;

import br.pucrio.olis.domain.DegreeUnit;

/**
 * @author Ingrid Nunes
 * 
 */
public class WeatherRequest implements Serializable {

	private static final long serialVersionUID = 3842748381932417140L;
	public static final String SEARCH_URL = "http://xoap.weather.com/weather/local/";
	public static final String PARTNER_ID = "1062114300";
	public static final String LICENSE_KEY = "9e401745dc5deaa1";

	private String localId;
	private boolean currentConditions;
	private int dayForecasts;
	private DegreeUnit degreeUnit;

	public WeatherRequest(String localId) {
		this.localId = localId;
		this.currentConditions = true;
		this.dayForecasts = 5;
		this.degreeUnit = DegreeUnit.CELSIUS;
	}

	public String getLocalId() {
		return localId;
	}

	public void setLocalId(String localId) {
		this.localId = localId;
	}

	public boolean isCurrentConditions() {
		return currentConditions;
	}

	public void setCurrentConditions(boolean currentConditions) {
		this.currentConditions = currentConditions;
	}

	public int getDayForecasts() {
		return dayForecasts;
	}

	public void setDayForecasts(int dayForecasts) {
		if (dayForecasts < 0 || dayForecasts > 5)
			throw new IndexOutOfBoundsException();
		this.dayForecasts = dayForecasts;
	}

	public DegreeUnit getDegreeUnit() {
		return degreeUnit;
	}

	public void setDegreeUnit(DegreeUnit degreeUnit) {
		this.degreeUnit = degreeUnit;
	}

	public String getURL() {
		StringBuffer sb = new StringBuffer();
		sb.append(SEARCH_URL).append("/").append(localId);
		sb.append("?");
		sb.append("par=").append(LICENSE_KEY);
		sb.append("&key=").append(PARTNER_ID);
		if (currentConditions) {
			sb.append("&cc=*");
		}
		if (dayForecasts > 0) {
			sb.append("&dayf=").append(dayForecasts);
		}
		sb.append("&unit=").append(
				DegreeUnit.CELSIUS.equals(degreeUnit) ? "m" : "s");
		return sb.toString();
	}

}
