/*
 * Created on Jun 20, 2008
 */
package br.pucrio.olis.agent.weather.service;

import java.io.Serializable;
import java.text.ParseException;

import org.restlet.resource.DomRepresentation;
import org.restlet.util.NodeSet;
import org.w3c.dom.Node;

import br.pucrio.olis.domain.weather.CurrentConditions;
import br.pucrio.olis.domain.weather.DayForecast;
import br.pucrio.olis.domain.weather.Head;
import br.pucrio.olis.domain.weather.Location;
import br.pucrio.olis.domain.weather.Weather;

/**
 * @author Ingrid Nunes
 * 
 */
public class WeatherResponse implements Serializable {

	private static final long serialVersionUID = 7010649291062169722L;

	private Weather weather;

	public WeatherResponse() {
	}

	public WeatherResponse(DomRepresentation document) throws ParseException {
		this();
		this.weather = new Weather();
		weather.setHead(new Head(document.getNodes("/weather/head").get(0)));
		weather.setLocation(new Location(document.getNodes("/weather/loc").get(
				0)));
		NodeSet set = document.getNodes("/weather/cc");
		if (!set.isEmpty()) {
			weather.setCurrentConditions(new CurrentConditions(set.get(0)));
		}
		for (Node node : document.getNodes("/weather/dayf/day")) {
			weather.addDayForecastList(new DayForecast(node));
		}
	}

	public Weather getWeather() {
		return weather;
	}

	public void setWeather(Weather weather) {
		this.weather = weather;
	}

	public String toString() {
		return weather.toString();
	}

}
