/*
 * Created on 04/06/2008
 */
package br.pucrio.olis.business.observer;

import br.pucrio.olis.business.BusinessOperation;

/**
 * <p>
 * This interface declares the method the business service observer must
 * implement.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public interface BusinessServiceObserver {

	/**
	 * <p>
	 * Notify an observer that a operation has been performed.
	 * </p>
	 * 
	 * @param observable
	 *            the service that performed the operation.
	 * @param operation
	 *            the operation performed.
	 */
	public void operationPerformed(final ObservableBusinessService observable,
			final BusinessOperation operation);

}
