/*
 * Created on 04/06/2008
 */
package br.pucrio.olis.business.observer;

/**
 * <p>
 * This interface declares the methods that the observable business services
 * must implement.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public interface ObservableBusinessService {

	/**
	 * <p>
	 * Add a new observer to the service.
	 * </p>
	 * 
	 * @param observer
	 *            the service observer.
	 */
	public void addObserver(BusinessServiceObserver observer);

	/**
	 * <p>
	 * Delete an observer from the service.
	 * </p>
	 * 
	 * @param observer
	 *            the service observer.
	 */
	public void deleteObserver(BusinessServiceObserver observer);

}
