/*
 * Created on May 5, 2008
 */
package br.pucrio.olis.business.service;

import java.util.List;

import br.pucrio.olis.business.BusinessException;
import br.pucrio.olis.business.observer.ObservableBusinessService;
import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.Country;

/**
 * <p>
 * This interface defines the services provided by the Location Service.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface LocationService extends ObservableBusinessService {

	/**
	 * The String indicates the service name.
	 */
	public static final String SERVICE_NAME = LocationService.class
			.getSimpleName();

	/**
	 * <p>
	 * Load all the countries.
	 * </p>
	 * 
	 * @return the List is the list of all countries.
	 */
	public List<Country> loadAllCountries() throws BusinessException;

	/**
	 * <p>
	 * Load all the cities of a country.
	 * </p>
	 * 
	 * @param country
	 *            the country.
	 * @return the List is the list of all cities of the provided country.
	 */
	public List<City> loadCitiesByCountry(Country country)
			throws BusinessException;

}
