/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.business.service;

import br.pucrio.olis.business.BusinessException;
import br.pucrio.olis.business.observer.ObservableBusinessService;
import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.DegreeUnit;
import br.pucrio.olis.domain.User;
import br.pucrio.olis.domain.WeatherUserService;
import br.pucrio.olis.domain.weather.Weather;

/**
 * <p>
 * This interface defines the services provided by the Weather Service.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface WeatherService extends ObservableBusinessService {

	/**
	 * The String indicates the service name.
	 */
	public static final String SERVICE_NAME = WeatherService.class
			.getSimpleName();

	/**
	 * <p>
	 * Gets the weather of the provided city.
	 * </p>
	 * 
	 * @param city
	 *            the city to get the weather.
	 * @unit the degree unit.
	 * @return the weather
	 * @throws BusinessException
	 */
	public Weather getWeather(City city, DegreeUnit unit)
			throws BusinessException;

	/**
	 * <p>
	 * Update a weather user service in the database.
	 * </p>
	 * 
	 * @param weatherUserService
	 * @return the user whose weather service was updated.
	 * @throws BusinessException
	 */
	public User update(WeatherUserService weatherUserService)
			throws BusinessException;

}
