/*
 * Created on May 5, 2008
 */
package br.pucrio.olis.business.service.impl;

import java.util.List;

import br.pucrio.olis.business.BusinessException;
import br.pucrio.olis.business.observer.ObservableBusinessServiceImpl;
import br.pucrio.olis.business.service.LocationService;
import br.pucrio.olis.data.dao.CityDAO;
import br.pucrio.olis.data.dao.CountryDAO;
import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.Country;

/**
 * <p>
 * This class implements the services provided by the Location Service.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class LocationServiceImpl extends ObservableBusinessServiceImpl
		implements LocationService {

	private CityDAO cityDAO;
	private CountryDAO countryDAO;

	public LocationServiceImpl(CountryDAO countryDAO, CityDAO cityDAO) {
		this.countryDAO = countryDAO;
		this.cityDAO = cityDAO;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.business.service.LocationService#loadAllCountry()
	 */
	@Override
	public List<Country> loadAllCountries() throws BusinessException {
		return countryDAO.loadAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.business.service.LocationService#loadCitiesByCountry(br.pucrio.olis.domain.Country)
	 */
	@Override
	public List<City> loadCitiesByCountry(Country country)
			throws BusinessException {
		return cityDAO.loadCitiesByCountry(country);
	}

}
