/*
 * Created on May 5, 2008
 */
package br.pucrio.olis.data.dao;

import java.util.List;

import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.Country;

/**
 * <p>
 * This class represents the data access object of the City domain entity.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface CityDAO extends GenericDAO<City> {

	/**
	 * <p>
	 * Load all the cities of a country.
	 * </p>
	 * 
	 * @param country
	 *            the country.
	 * @return the List is the list of all cities of the provided country.
	 */
	public List<City> loadCitiesByCountry(Country country);

}
