/*
 * Created on May 24, 2008
 */
package br.pucrio.olis.data.dao;

import java.util.Date;
import java.util.List;

import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.EventsAnnouncementUserService;

/**
 * <p>
 * This class represents the data access object of the
 * EventsAnnouncementUserService domain entity.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface EventsAnnouncementUserServiceDAO extends
		GenericDAO<EventsAnnouncementUserService> {

	/**
	 * <p>
	 * Load a list of events the occurs in a specific time.
	 * </p>
	 * 
	 * @param start
	 *            the start date.
	 * @param end
	 *            the end date.
	 * @return the list of events.
	 */
	public List<Event> loadEventsBetweenDates(Date start, Date end);

	/**
	 * <p>
	 * Load a list of periodic events the occurs in a specific time.
	 * Periodic events are the ones whose frequency is not Frequency.ONCE.
	 * </p>
	 * 
	 * @param start
	 *            the start date.
	 * @param end
	 *            the end date.
	 * @return the list of events.
	 */
	public List<Event> loadPeriodicEventBetweenDates(Date start, Date end);

}
