/*
 * Created on May 22, 2008
 */
package br.pucrio.olis.data.dao;

import org.springframework.dao.DataAccessException;

import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.EventsBoard;

/**
 * <p>
 * This class represents the data access object of the EventsBoard domain
 * entity.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface EventsBoardDAO extends GenericDAO<EventsBoard> {

	/**
	 * <p>
	 * Add an event from the events board.
	 * </p>
	 * 
	 * @param event
	 *            the event to be added.
	 * @throws DataAccessException
	 */
	public void addEvent(Event event) throws DataAccessException;

	/**
	 * <p>
	 * Read the singleton entity.
	 * </p>
	 * 
	 * @return the singleton instance of EventsBoard.
	 * @throws DataAccessException
	 */
	public EventsBoard get() throws DataAccessException;

	/**
	 * <p>
	 * Remove an event from the events board.
	 * </p>
	 * 
	 * @param event
	 *            the event to be removed.
	 * @return true if the event was removed.
	 * @throws DataAccessException
	 */
	public boolean removeEvent(Event event) throws DataAccessException;

}
