/*
 * Created on May 25, 2008
 */
package br.pucrio.olis.data.dao.factory;

import br.pucrio.olis.domain.UserPreferences;

/**
 * <p>
 * This interface provides the method to instantiate the appropriate user
 * preferences according to the event type.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface UserPreferencesAbstractFactory {

	/**
	 * <p>
	 * Instantiates an UserPreferences.
	 * </p>
	 * 
	 * @return the user preferences.
	 */
	public UserPreferences createUserPreferences();

}
