/*
 * Created on May 5, 2008
 */
package br.pucrio.olis.data.hibernate.dao;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.orm.hibernate3.HibernateCallback;

import br.pucrio.olis.data.dao.CityDAO;
import br.pucrio.olis.domain.City;
import br.pucrio.olis.domain.Country;

/**
 * <p>
 * This class is the hibernate implementation of the city data access object.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class CityDAOHibernate extends GenericDAOHibernate<City> implements
		CityDAO {

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#getEntityClass()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		return City.class;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.dao.CityDAO#loadCitiesByCountry(br.pucrio.olis.domain.Country)
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<City> loadCitiesByCountry(final Country country) {
		return (List<City>) getHibernateTemplate().execute(
				new HibernateCallback() {
					public Object doInHibernate(Session session)
							throws HibernateException {
						return session.createCriteria(City.class).add(
								Restrictions.eq("country", country)).list();
					}
				});
	}

}
