/*
 * Created on May 20, 2008
 */
package br.pucrio.olis.data.hibernate.dao;

import org.springframework.dao.DataAccessException;

import br.pucrio.olis.data.dao.EventDAO;
import br.pucrio.olis.domain.Event;

/**
 * <p>
 * This class is the hibernate implementation of the event data access object.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class EventDAOHibernate extends GenericDAOHibernate<Event> implements
		EventDAO {

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#getEntityClass()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		return Event.class;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#update(java.lang.Object)
	 */
	@Override
	public void update(Event entity) throws DataAccessException {
		Event event = super.get(entity.getId());
		event.setAllDay(entity.getAllDay());
		event.setCity(entity.getCity());
		event.setDescription(entity.getDescription());
		event.setEnd(entity.getEnd());
		event.setEndTime(entity.getEndTime());
		event.setFrequency(entity.getFrequency());
		event.setLocation(entity.getLocation());
		event.setStart(entity.getStart());
		event.setStartTime(entity.getStartTime());
		event.setSubject(entity.getSubject());
		super.update(event);
	}

}
