/*
 * Created on May 22, 2008
 */
package br.pucrio.olis.data.hibernate.dao;

import java.io.Serializable;

import org.springframework.dao.DataAccessException;

import br.pucrio.olis.data.dao.EventsBoardDAO;
import br.pucrio.olis.domain.Event;
import br.pucrio.olis.domain.EventsBoard;

/**
 * <p>
 * This class is the hibernate implementation of the events board data access
 * object.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class EventsBoardDAOHibernate extends GenericDAOHibernate<EventsBoard>
		implements EventsBoardDAO {

	/**
	 * <p>
	 * Indicates the id of the events board singleton instance.
	 * </p>
	 */
	private static final Long ID = new Long(1);

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.dao.EventsBoardDAO#addEvent(br.pucrio.olis.domain.Event)
	 */
	@Override
	public void addEvent(Event event) throws DataAccessException {
		get().addEvents(event);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#delete(java.lang.Object)
	 */
	@Override
	public void delete(EventsBoard entity) throws DataAccessException {
		throw new UnsupportedOperationException("Singleton instance.");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.dao.EventsBoardDAO#get()
	 */
	@Override
	public EventsBoard get() throws DataAccessException {
		return super.get(ID);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#get(java.io.Serializable)
	 */
	@Override
	public EventsBoard get(Serializable id) throws DataAccessException {
		throw new UnsupportedOperationException("Singleton instance.");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#getEntityClass()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		return EventsBoard.class;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.dao.EventsBoardDAO#removeEvent(br.pucrio.olis.domain.Event)
	 */
	@Override
	public boolean removeEvent(Event event) throws DataAccessException {
		return get().removeEvents(event);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#save(java.lang.Object)
	 */
	@Override
	public Serializable save(EventsBoard entity) throws DataAccessException {
		throw new UnsupportedOperationException("Singleton instance.");
	}

}
