/*
 * Created on 23/06/2008
 */
package br.pucrio.olis.data.hibernate.dao;

import org.springframework.dao.DataAccessException;

import br.pucrio.olis.data.dao.WeatherUserServiceDAO;
import br.pucrio.olis.domain.WeatherUserService;

/**
 * <p>
 * This class is the hibernate implementation of the weather user service data
 * access object.
 * </p>
 * 
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class WeatherUserServiceDAOHibernate extends
		GenericDAOHibernate<WeatherUserService> implements
		WeatherUserServiceDAO {

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#getEntityClass()
	 */
	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		return WeatherUserService.class;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see br.pucrio.olis.data.hibernate.dao.GenericDAOHibernate#update(java.lang.Object)
	 */
	@Override
	public void update(WeatherUserService entity) throws DataAccessException {
		WeatherUserService weatherUserService = super.get(entity.getId());
		weatherUserService.setDefaultCity(entity.getDefaultCity());
		weatherUserService.setDegreeUnit(entity.getDegreeUnit());
	}

}
