/*
 * Created on May 24, 2008
 */
package br.pucrio.olis.domain;

import jade.content.Concept;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * @author Ingrid Nunes
 * 
 */
/**
 * <p>
 * This class represents the possible areas of interest that an academic event
 * can have.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
@Entity
public class AreaOfInterest implements Serializable, Concept {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -9127920505924112872L;

	/**
	 * The Long represents the place type unique identifier.
	 */
	private Long id;
	/**
	 * The String represents the label of the place type.
	 */
	private String label;

	/**
	 * <p>
	 * Create a new instance of AreaOfInterest.
	 * </p>
	 */
	public AreaOfInterest() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof AreaOfInterest))
			return false;
		return id.equals(((AreaOfInterest) obj).getId());
	}

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	public Long getId() {
		return id;
	}

	public String getLabel() {
		return label;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return id.hashCode();
	}

	public void setId(Long id) {
		this.id = id;
	}

	public void setLabel(String label) {
		this.label = label;
	}

}
