/*
 * Created on May 1, 2008
 */
package br.pucrio.olis.domain;

import jade.content.Concept;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;

/**
 * <p>
 * This class represents a country. It has a code, such as BR, and a name.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
@Entity
public class Country implements Serializable, Concept {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 8752321504937538793L;

	/**
	 * The String represents the country unique identifier.
	 */
	private String code;
	/**
	 * The String represents the country name.
	 */
	private String name;

	/**
	 * <p>
	 * Create a new instance of Country.
	 * </p>
	 */
	public Country() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof Country))
			return false;
		return code.equals(((Country) obj).getCode());
	}

	@Id
	public String getCode() {
		return code;
	}

	@Column(nullable = false)
	public String getName() {
		return name;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return code.hashCode();
	}

	public void setCode(String code) {
		this.code = code;
	}

	public void setName(String name) {
		this.name = name;
	}

}
