/*
 * Created on May 24, 2008
 */
package br.pucrio.olis.domain;

/**
 * <p>
 * This enumeration contains the possible deadline of an academic event.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public enum Deadline {

	ACCEPT_REVIEW("deadline.accept.review"), REGISTER_PAPER("deadline.register.paper"), REVIEW_PAPER(
			"deadline.review.paper"), SUBMIT_CAMERA_READY(
			"deadline.submit.camera.ready"), SUBMIT_PAPER("deadline.submit.paper");

	/**
	 * The String represents the label of the deadline.
	 */
	private String label;

	/**
	 * <p>
	 * Set the label of the deadline.
	 * </p>
	 * 
	 * @param label.
	 */
	private Deadline(final String label) {
		this.label = label;
	}

	/**
	 * <p>
	 * Return a specific label.
	 * </p>
	 * 
	 * @return label.
	 */
	public String getLabel() {
		return label;
	}

}
