/*
 * Created on May 1, 2008
 */
package br.pucrio.olis.domain;

/**
 * <p>
 * This enumeration contains the degree units that the weather can be displayed.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public enum DegreeUnit {
	CELSIUS("C", "celsius"), FAHRENHEIT("F", "fahrenheit");

	/**
	 * The String represents the label of the degree unit.
	 */
	private String label;
	/**
	 * The String represents the symbol that represents the degree unit.
	 */
	private String symbol;

	/**
	 * <p>
	 * Create a new instance of DegreeUnit.
	 * </p>
	 */
	private DegreeUnit(String symbol, String label) {
		this.symbol = symbol;
		this.label = label;
	}

	public String getLabel() {
		return label;
	}

	public String getSymbol() {
		return symbol;
	}

}
