/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.domain;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

/**
 * @author Ingrid Nunes
 * 
 */
@Entity
public class EventSchedulerNotification extends Notification {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 7783706342860391988L;

	private CalendarEvent calendarEvent;
	private User conflict;
	private Date suggestedEnd;
	private Date suggestedStart;

	/**
	 * <p>
	 * Create a new instance of Notification.
	 * </p>
	 */
	public EventSchedulerNotification() {

	}

	@ManyToOne
	@OnDelete(action = OnDeleteAction.CASCADE)
	public CalendarEvent getCalendarEvent() {
		return calendarEvent;
	}

	@ManyToOne
	public User getConflict() {
		return conflict;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(nullable = false)
	public Date getSuggestedEnd() {
		return suggestedEnd;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(nullable = false)
	public Date getSuggestedStart() {
		return suggestedStart;
	}

	public void setCalendarEvent(CalendarEvent calendarEvent) {
		this.calendarEvent = calendarEvent;
	}

	public void setConflict(User conflict) {
		this.conflict = conflict;
	}

	public void setSuggestedEnd(Date suggestedEnd) {
		this.suggestedEnd = suggestedEnd;
	}

	public void setSuggestedStart(Date suggestedStart) {
		this.suggestedStart = suggestedStart;
	}

}
