/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.domain.weather;

import jade.content.Concept;

import java.io.Serializable;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class Barometric implements Serializable, Concept {

	private static final long serialVersionUID = -296630382971094929L;

	private Double pressure;
	private String trend;

	public Barometric() {
	}

	public Barometric(Node node) {
		NodeList list = node.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			Node child = list.item(i);
			if (child.getNodeName().equals("r")) {
				try {
					this.pressure = Double.parseDouble(child.getTextContent());
				} catch (NumberFormatException e) {
					this.pressure = null;
				}
			} else if (child.getNodeName().equals("d")) {
				this.trend = child.getTextContent();
			}
		}
	}

	public Double getPressure() {
		return pressure;
	}

	public String getTrend() {
		return trend;
	}

	public void setPressure(Double pressure) {
		this.pressure = pressure;
	}

	public void setTrend(String trend) {
		this.trend = trend;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("pressure: ").append(pressure).append("\n");
		sb.append("trend: ").append(trend);
		return sb.toString();
	}

}
