/*
 * Created on Jun 20, 2008
 */
package br.pucrio.olis.domain.weather;

import jade.content.Concept;

import java.io.Serializable;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import br.pucrio.olis.domain.DegreeUnit;

/**
 * @author Ingrid Nunes
 * 
 */
public class Head implements Serializable, Concept {

	private static final long serialVersionUID = -4823153955034340423L;

	private DegreeUnit degreeUnit;
	private String distanceUnit;
	private String form;
	private String locale;
	private String pressureUnit;
	private String rainUnit;
	private String speedUnit;

	public Head() {
	}

	public Head(Node node) {
		NodeList list = node.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			Node child = list.item(i);
			if (child.getNodeName().equals("locale")) {
				this.locale = child.getTextContent();
			} else if (child.getNodeName().equals("form")) {
				this.form = child.getTextContent();
			} else if (child.getNodeName().equals("ut")) {
				if (DegreeUnit.CELSIUS.getSymbol().equals(
						child.getTextContent())) {
					this.degreeUnit = DegreeUnit.CELSIUS;
				} else {
					this.degreeUnit = DegreeUnit.FAHRENHEIT;
				}
			} else if (child.getNodeName().equals("ud")) {
				this.distanceUnit = child.getTextContent();
			} else if (child.getNodeName().equals("us")) {
				this.speedUnit = child.getTextContent();
			} else if (child.getNodeName().equals("up")) {
				this.pressureUnit = child.getTextContent();
			} else if (child.getNodeName().equals("ur")) {
				this.rainUnit = child.getTextContent();
			}
		}
	}

	public DegreeUnit getDegreeUnit() {
		return degreeUnit;
	}

	public String getDistanceUnit() {
		return distanceUnit;
	}

	public String getForm() {
		return form;
	}

	public String getLocale() {
		return locale;
	}

	public String getPressureUnit() {
		return pressureUnit;
	}

	public String getRainUnit() {
		return rainUnit;
	}

	public String getSpeedUnit() {
		return speedUnit;
	}

	public void setDegreeUnit(DegreeUnit degreeUnit) {
		this.degreeUnit = degreeUnit;
	}

	public void setDistanceUnit(String distanceUnit) {
		this.distanceUnit = distanceUnit;
	}

	public void setForm(String form) {
		this.form = form;
	}

	public void setLocale(String locale) {
		this.locale = locale;
	}

	public void setPressureUnit(String pressureUnit) {
		this.pressureUnit = pressureUnit;
	}

	public void setRainUnit(String rainUnit) {
		this.rainUnit = rainUnit;
	}

	public void setSpeedUnit(String speedUnit) {
		this.speedUnit = speedUnit;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("locale: ").append(locale).append("\n");
		sb.append("form: ").append(form).append("\n");
		sb.append("degreeUnit: ").append(degreeUnit).append("\n");
		sb.append("distanceUnit: ").append(distanceUnit).append("\n");
		sb.append("speedUnit: ").append(speedUnit).append("\n");
		sb.append("pressureUnit: ").append(pressureUnit).append("\n");
		sb.append("rainUnit: ").append(rainUnit);
		return sb.toString();
	}

}
