/*
 * Created on Jun 20, 2008
 */
package br.pucrio.olis.domain.weather;

import jade.content.Concept;

import java.io.Serializable;

import org.w3c.dom.Node;

/**
 * @author Ingrid Nunes
 * 
 */
public class LocationSimple implements Serializable, Concept {

	private static final long serialVersionUID = -1429378636782882954L;

	private String id;
	private Integer type;
	private String name;

	public LocationSimple() {
	}

	public LocationSimple(Node node) {
		this.id = node.getAttributes().getNamedItem("id").getTextContent();
		try {
			this.type = Integer.parseInt(node.getAttributes().getNamedItem(
					"type").getTextContent());
		} catch (NumberFormatException e) {
			this.type = null;
		}
		this.name = node.getTextContent();
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public Integer getType() {
		return type;
	}

	public void setType(Integer type) {
		this.type = type;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String toString() {
		return "[" + id + "] " + name + " (type = " + type + ")";
	}

}
