/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.domain.weather;

import jade.content.Concept;

import java.io.Serializable;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class Moon implements Serializable, Concept {

	private static final long serialVersionUID = 4951336971903787664L;

	private String description;
	private Integer icon;

	public Moon() {
	}

	public Moon(Node node) {
		NodeList list = node.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			Node child = list.item(i);
			if (child.getNodeName().equals("icon")) {
				try {
					this.icon = Integer.parseInt(child.getTextContent());
				} catch (NumberFormatException e) {
					this.icon = null;
				}
			} else if (child.getNodeName().equals("t")) {
				this.description = child.getTextContent();
			}
		}
	}

	public String getDescription() {
		return description;
	}

	public Integer getIcon() {
		return icon;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public void setIcon(Integer icon) {
		this.icon = icon;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("icon: ").append(icon).append("\n");
		sb.append("gust: ").append(description);
		return sb.toString();
	}

}
