/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.domain.weather;

import jade.content.Concept;

import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class Weather implements Serializable, Concept {

	private static final long serialVersionUID = 3091131747348472041L;
	
	public static final DateFormat DATE_FORMAT = new SimpleDateFormat(
			"MMM dd yyyy");
	public static final DateFormat DATE_FORMAT_LONG = new SimpleDateFormat(
			"MM/dd/yy hh:mm a");
	public static final DateFormat TIME_FORMAT = new SimpleDateFormat("hh:mm a");

	private CurrentConditions currentConditions;
	private List<DayForecast> dayForecastList;
	private Head head;
	private Location location;

	public Weather() {
		this.dayForecastList = new ArrayList<DayForecast>();
	}

	public void addDayForecastList(DayForecast dayForecast) {
		this.dayForecastList.add(dayForecast);
	}

	public Iterator<DayForecast> getAllDayForecastList() {
		return dayForecastList.iterator();
	}

	public CurrentConditions getCurrentConditions() {
		return currentConditions;
	}

	public List<DayForecast> getDayForecastList() {
		return dayForecastList;
	}

	public Head getHead() {
		return head;
	}

	public Location getLocation() {
		return location;
	}

	public void setCurrentConditions(CurrentConditions currentConditions) {
		this.currentConditions = currentConditions;
	}

	public void setDayForecastList(List<DayForecast> dayForecastList) {
		this.dayForecastList = dayForecastList;
	}

	public void setHead(Head head) {
		this.head = head;
	}

	public void setLocation(Location location) {
		this.location = location;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("HEAD\n");
		sb.append(head).append("\n");
		sb.append("LOCATION\n");
		sb.append(location).append("\n");
		if (currentConditions != null) {
			sb.append("CURRENT CONDITIONS\n");
			sb.append(currentConditions).append("\n");
		}
		if (!dayForecastList.isEmpty()) {
			sb.append("DAY FORECAST\n");
			for (DayForecast dayForecast : dayForecastList) {
				sb.append(dayForecast).append("\n");
			}
		}
		return sb.toString();
	}

}
