/*
 * Created on 20/06/2008
 */
package br.pucrio.olis.domain.weather;

import jade.content.Concept;

import java.io.Serializable;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public class Wind implements Serializable, Concept {

	private static final long serialVersionUID = 645857909161206993L;

	private Integer direction;
	private String directionPhrase;
	private String gust;
	private Integer speed;

	public Wind() {
	}

	public Wind(Node node) {
		NodeList list = node.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			Node child = list.item(i);
			if (child.getNodeName().equals("s")) {
				try {
					this.speed = Integer.parseInt(child.getTextContent());
				} catch (NumberFormatException e) {
					this.speed = null;
				}
			} else if (child.getNodeName().equals("gust")) {
				this.gust = child.getTextContent();
			} else if (child.getNodeName().equals("d")) {
				try {
					this.direction = Integer.parseInt(child.getTextContent());
				} catch (NumberFormatException e) {
					this.direction = null;
				}
			} else if (child.getNodeName().equals("t")) {
				this.directionPhrase = child.getTextContent();
			}
		}
	}

	public Integer getDirection() {
		return direction;
	}

	public String getDirectionPhrase() {
		return directionPhrase;
	}

	public String getGust() {
		return gust;
	}

	public Integer getSpeed() {
		return speed;
	}

	public void setDirection(Integer direction) {
		this.direction = direction;
	}

	public void setDirectionPhrase(String directionPhrase) {
		this.directionPhrase = directionPhrase;
	}

	public void setGust(String gust) {
		this.gust = gust;
	}

	public void setSpeed(Integer speed) {
		this.speed = speed;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("speed: ").append(speed).append("\n");
		sb.append("gust: ").append(gust).append("\n");
		sb.append("direction: ").append(direction).append("\n");
		sb.append("directionPhrase: ").append(directionPhrase);
		return sb.toString();
	}

}
