/*
 * Created on Jun 22, 2008
 */
package br.pucrio.olis.ontology;

import jade.content.onto.BasicOntology;
import jade.content.onto.Ontology;
import jade.content.onto.OntologyException;
import jade.content.schema.ConceptSchema;
import jade.content.schema.ObjectSchema;
import jade.content.schema.PredicateSchema;
import jade.content.schema.PrimitiveSchema;
import br.pucrio.olis.agent.eventsuggestion.EventInterestAnswer;
import br.pucrio.olis.agent.eventsuggestion.EventInterestQuery;
import br.pucrio.olis.domain.EventSuggestionNotification;

/**
 * @author Ingrid Nunes
 *
 */
public class OLISEventSuggestionOntology extends Ontology implements OLISEventSuggestionVocabulary {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 6113260660006024268L;

	public static final String ONTOLOGY_NAME = "OLISEventSuggestionOntology";
	private static Ontology theInstance = new OLISEventSuggestionOntology();

	/**
	 * This method grants access to the unique instance of the ontology.
	 * 
	 * @return An <code>Ontology</code> object, containing the concepts of the
	 *         ontology.
	 */
	public static Ontology getInstance() {
		return theInstance;
	}

	public OLISEventSuggestionOntology() {
		super(ONTOLOGY_NAME, new Ontology[] { OLISBasicOntology.getInstance() },
				new OLISIntrospector());

		try {
			add(new ConceptSchema(EVENTSUGGESTIONNOTIFICATION), EventSuggestionNotification.class);
			
			ConceptSchema cs = (ConceptSchema) getSchema(EVENTSUGGESTIONNOTIFICATION);
			cs.add(EVENTSUGGESTIONNOTIFICATION_EVENT, (ConceptSchema) getSchema(OLISBasicOntology.EVENT));
			cs.addSuperSchema((ConceptSchema) getSchema(OLISBasicOntology.NOTIFICATION));
			
			add(new PredicateSchema(EVENTINTERESTQUERY), EventInterestQuery.class);
			add(new PredicateSchema(EVENTINTERESTANSWER), EventInterestAnswer.class);

			PredicateSchema ps = (PredicateSchema) getSchema(EVENTINTERESTQUERY);
			ps.add(EVENTINTERESTQUERY_EVENT, (ConceptSchema) getSchema(OLISBasicOntology.EVENT));

			ps = (PredicateSchema) getSchema(EVENTINTERESTANSWER);
			ps.add(EVENTINTERESTANSWER_EVENT, (ConceptSchema) getSchema(OLISBasicOntology.EVENT));
			ps.add(EVENTINTERESTANSWER_REASON, (PrimitiveSchema) getSchema(BasicOntology.STRING), 0, ObjectSchema.UNLIMITED, BasicOntology.SET);
		} catch (OntologyException oe) {
			oe.printStackTrace();
		}
	}
	
}
