/*
 * Created on 17/06/2008
 */
package br.pucrio.olis.ontology;

import jade.content.abs.AbsObject;
import jade.content.abs.AbsPrimitive;
import jade.content.onto.BCReflectiveIntrospector;
import jade.content.onto.Ontology;
import jade.content.onto.OntologyException;
import jade.content.schema.ObjectSchema;

import java.lang.reflect.Method;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
@SuppressWarnings("unchecked")
public class OLISIntrospector extends BCReflectiveIntrospector {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = 2464170261735572000L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see jade.content.onto.BCReflectiveIntrospector#externalise(java.lang.Object,
	 *      jade.content.schema.ObjectSchema, java.lang.Class,
	 *      jade.content.onto.Ontology)
	 */
	@Override
	public AbsObject externalise(Object obj, ObjectSchema schema,
			Class javaClass, Ontology referenceOnto) throws OntologyException {
		if (schema instanceof EnumerationSchema) {
			return AbsPrimitive.wrap(obj.toString());
		} else {
			return super.externalise(obj, schema, javaClass, referenceOnto);
		}
	}

	protected void invokeSetterMethod(Method method, Object obj, Object value)
			throws OntologyException {
		if (method.getParameterTypes()[0].isEnum()) {
			Object[] enumContants = method.getParameterTypes()[0]
					.getEnumConstants();
			for (Object enumValue : enumContants) {
				if (value.equals(enumValue.toString())) {
					Object[] params = new Object[] { enumValue };
					try {
						method.invoke(obj, params);
						return;
					} catch (Exception e) {
						e.printStackTrace();
					}

				}
			}
		}

		super.invokeSetterMethod(method, obj, value);
	}

}
