/*
 * Created on 17/06/2008
 */
package br.pucrio.olis.ontology;

/**
 * @author ingridnunes
 * @version 1.0
 * 
 */
public interface OLISVocabulary {
	
	/** Concepts **/
	
	public static final String OBJECT = "object";
	
	public static final String ACADEMICEVENTTYPE = "AcademicEventType";
	public static final String DATEFORMAT = "DateFormat";
	public static final String DEADLINE = "Deadline";
	public static final String DEGREEUNIT = "DegreeUnit";
	public static final String FREQUENCY = "Frequency";
	public static final String BUSINESSOPERATIONTYPE = "BusinessOperationType";
	public static final String TIMEFORMAT = "TimeFormat";
	public static final String DAYPARTTYPE = "DayPartType";
	
	public static final String ACADEMICEVENT = "AcademicEvent";
	public static final String ACADEMICEVENT_AREASOFINTEREST = "areasOfInterest";
	public static final String ACADEMICEVENT_DEADLINES = "deadlines";
	public static final String ACADEMICEVENT_EVENTTYPE = "eventType";
	
	public static final String ACADEMICPREFERENCES = "AcademicPreferences";
	public static final String ACADEMICPREFERENCES_AREASOFINTEREST = "areasOfInterest";
	public static final String ACADEMICPREFERENCES_EVENTTYPE = "eventTypes";
	public static final String ACADEMICPREFERENCES_FOREIGNEVENTS = "foreignEvents";
	
	public static final String ACTIVITYTYPE = "ActivityType";
	public static final String ACTIVITYTYPE_ID = "id";
	public static final String ACTIVITYTYPE_LABEL = "label";
	
	public static final String AREAOFINTEREST = "AreaOfInterest";
	public static final String AREAOFINTEREST_ID = "id";
	public static final String AREAOFINTEREST_LABEL = "label";
	
	public static final String CALENDAREVENT = "CalendarEvent";
	public static final String CALENDAREVENT_AVAILABLE = "available";
	public static final String CALENDAREVENT_EVENT = "event";
	public static final String CALENDAREVENT_ID = "id";
	public static final String CALENDAREVENT_PARTICIPANTS = "participants";
	
	public static final String CALENDARUSERSERVICE = "CalendarUserService";
	public static final String CALENDARUSERSERVICE_EVENTS = "events";
	public static final String CALENDARUSERSERVICE_REMINDEVENT = "remindEvents";
	public static final String CALENDARUSERSERVICE_REMINDMINUTESBEFORE = "remindMinutesBefore";
	public static final String CALENDARUSERSERVICE_SHOWWEEKENDS = "showWeekends";
	
	public static final String CITY = "City";
	public static final String CITY_COUNTRY = "country";
	public static final String CITY_ID = "id";
	public static final String CITY_NAME = "name";
	
	public static final String COUNTRY = "Country";
	public static final String COUNTRY_CITIES = "cities";
	public static final String COUNTRY_CODE = "code";
	public static final String COUNTRY_NAME = "name";
	
	public static final String DEADLINEDATE = "DeadlineDate";
	public static final String DEADLINEDATE_ACADEMICEVENT = "academicEvent";
	public static final String DEADLINEDATE_DATE = "date";
	public static final String DEADLINEDATE_DEADLINE = "deadline";
	public static final String DEADLINEDATE_ID = "id";
	
	public static final String EVENT = "Event";
	public static final String EVENT_ALLDAY = "allDay";
	public static final String EVENT_CITY = "city";
	public static final String EVENT_DESCRIPTION = "description";
	public static final String EVENT_END = "end";
	public static final String EVENT_ENDTIME = "endTime";
	public static final String EVENT_EVENTSBOARD = "eventsBoard";
	public static final String EVENT_FREQUENCY = "frequency";
	public static final String EVENT_ID = "id";
	public static final String EVENT_LOCATION = "location";
	public static final String EVENT_OWNER = "owner";
	public static final String EVENT_START = "start";
	public static final String EVENT_STARTTIME = "startTime";
	public static final String EVENT_SUBJECT = "subject";
	
	public static final String EVENTSANNOUNCEMENTUSERSERVICE = "EventsAnnouncementUserService";
	public static final String EVENTSANNOUNCEMENTUSERSERVICE_SUGGESTEVENTS = "suggestEvents";
	public static final String EVENTSANNOUNCEMENTUSERSERVICE_WORKTIMEBEGIN = "workTimeBegin";
	public static final String EVENTSANNOUNCEMENTUSERSERVICE_WORKTIMEEND = "workTimeEnd";
	
	public static final String EVENTSUGGESTIONNOTIFICATION = "EventSuggestionNotification";
	public static final String EVENTSUGGESTIONNOTIFICATION_EVENT = "event";
	
	public static final String EVENTSBOARD = "EventsBoard";
	public static final String EVENTSBOARD_EVENTS = "events";
	public static final String EVENTSBOARD_ID = "id";
	
	public static final String NOTIFICATION = "Notification";
	public static final String NOTIFICATION_ID = "id";
	public static final String NOTIFICATION_DATE = "date";
	
	public static final String PLACETYPE = "PlaceType";
	public static final String PLACETYPE_ID = "id";
	public static final String PLACETYPE_LABEL = "label";
	
	public static final String TRAVELEVENT = "TravelEvent";
	public static final String TRAVELEVENT_ACTIVITIES = "activities";
	public static final String TRAVELEVENT_PLACETYPE = "placeType";
	
	public static final String TRAVELPREFERENCES = "TravelPreferences";
	public static final String TRAVELPREFERENCES_ACTIVITIES = "activities";
	public static final String TRAVELPREFERENCES_PLACETYPES = "placeTypes";
	
	public static final String USER = "User";
	public static final String USER_CITY = "city";
	public static final String USER_DATEFORMAT = "dateFormat";
	public static final String USER_DATEOFBIRTH = "dateOfBirth";
	public static final String USER_EMAIL = "email";
	public static final String USER_FIRSTNAME = "firstName";
	public static final String USER_ID = "id";
	public static final String USER_LASTNAME = "lastName";
	public static final String USER_NOTIFICATIONS = "notifications";
	public static final String USER_PASSWORD = "password";
	public static final String USER_PREFERENCES = "preferences";
	public static final String USER_SERVICES = "services";
	public static final String USER_TIMEFORMAT = "timeFormat";
	public static final String USER_USERNAME = "username";
	
	public static final String USERPREFERENCES = "UserPreferences";
	public static final String USERPREFERENCES_ID = "id";
	public static final String USERPREFERENCES_USER = "user";
	
	public static final String USERSERVICE = "UserService";
	public static final String USERSERVICE_ID = "id";
	public static final String USERSERVICE_USER = "user";
	
	public static final String WEATHERUSERSERVICE = "WeatherUserService";
	public static final String WEATHERUSERSERVICE_DEFAULTCITY = "defaultCity";
	public static final String WEATHERUSERSERVICE_DEGREEUNIT = "degreeUnit";
	
	public static final String BAROMETRIC = "Barometric";
	public static final String BAROMETRIC_PRESSURE = "pressure";
	public static final String BAROMETRIC_TREND = "trend";
	
	public static final String CURRENTCONDITIONS = "CurrentConditions";
	public static final String CURRENTCONDITIONS_BAROMETRIC = "barometric";
	public static final String CURRENTCONDITIONS_DATEOFOBSERVATION = "dateOfObservation";
	public static final String CURRENTCONDITIONS_DESCRIPTION = "description";
	public static final String CURRENTCONDITIONS_DEWPOINT = "dewPoint";
	public static final String CURRENTCONDITIONS_FEELLIKETEMPERATURE = "feelLikeTemperature";
	public static final String CURRENTCONDITIONS_HUMIDITY = "humidity";
	public static final String CURRENTCONDITIONS_ICON = "icon";
	public static final String CURRENTCONDITIONS_MOON = "moon";
	public static final String CURRENTCONDITIONS_OBSERVATIONSTATION = "observationStation";
	public static final String CURRENTCONDITIONS_TEMPERATURE = "temperature";
	public static final String CURRENTCONDITIONS_UV = "uv";
	public static final String CURRENTCONDITIONS_VISIBILITY = "visibility";
	public static final String CURRENTCONDITIONS_WIND = "wind";
	
	public static final String DAYFORECAST = "DayForecast";
	public static final String DAYFORECAST_DAY = "day";
	public static final String DAYFORECAST_DAYNUMBER = "dayNumber";
	public static final String DAYFORECAST_DAYOFMONTH = "dayOfMonth";
	public static final String DAYFORECAST_HIGHTEMPERATURE = "highTemperature";
	public static final String DAYFORECAST_LOWTEMPERATURE = "lowTemperature";
	public static final String DAYFORECAST_NIGHT = "night";
	public static final String DAYFORECAST_SUNRISE = "sunrise";
	public static final String DAYFORECAST_SUNSET = "sunset";
	
	public static final String DAYPART = "DayPart";
	public static final String DAYPART_CHANCEOFPRECIPITATION = "chanceOfPrecipitation";
	public static final String DAYPART_DESCRIPTION = "description";
	public static final String DAYPART_DESCRIPTIONSHORT = "descriptionShort";
	public static final String DAYPART_HUMIDITY = "humidity";
	public static final String DAYPART_ICON = "icon";
	public static final String DAYPART_TYPE = "type";
	public static final String DAYPART_WIND = "wind";
	
	public static final String HEAD = "Head";
	public static final String HEAD_DEGREEUNIT = "degreeUnit";
	public static final String HEAD_DISTANCEUNIT = "distanceUnit";
	public static final String HEAD_FORM = "form";
	public static final String HEAD_LOCALE = "locale";
	public static final String HEAD_PRESSUREUNIT = "pressureUnit";
	public static final String HEAD_RAINUNIT = "rainUnit";
	public static final String HEAD_SPEEDUNIT = "speedUnit";
	
	public static final String LOCATION = "Location";
	public static final String LOCATION_ID = "id";
	public static final String LOCATION_LATITUDE = "latitude";
	public static final String LOCATION_LONGITUDE = "longitude";
	public static final String LOCATION_NAME = "name";
	public static final String LOCATION_SUNRISE = "sunrise";
	public static final String LOCATION_SUNSET = "sunset";
	public static final String LOCATION_TIME = "time";
	public static final String LOCATION_ZONE = "zone";
	
	public static final String LOCATIONSIMPLE = "LocationSimple";
	public static final String LOCATIONSIMPLE_ID = "id";
	public static final String LOCATIONSIMPLE_TYPE = "type";
	public static final String LOCATIONSIMPLE_NAME = "name";
	
	public static final String MOON = "Moon";
	public static final String MOON_DESCRIPTION = "description";
	public static final String MOON_ICON = "icon";
	
	public static final String UV = "UV";
	public static final String UV_DESCRIPTION = "description";
	public static final String UV_INDEX = "index";
	
	public static final String WEATHER = "Weather";
	public static final String WEATHER_CURRENTCONDITIONS = "currentConditions";
	public static final String WEATHER_DAYFORCASTLIST = "dayForecastList";
	public static final String WEATHER_HEAD = "head";
	public static final String WEATHER_LOCATION = "location";
	
	public static final String WIND = "Wind";
	public static final String WIND_DIRECTION = "direction";
	public static final String WIND_DIRECTIONPHRASE = "directionPhrase";
	public static final String WIND_GUST = "gust";
	public static final String WIND_SPEED = "speed";
	
	/** Predicates **/

	public static final String BUSINESSOPERATION = "BusinessOperation";
	public static final String BUSINESSOPERATION_TARGETCLASS = "targetClass";
	public static final String BUSINESSOPERATION_TARGETID = "targetId";
	public static final String BUSINESSOPERATION_PARAM = "param";
	public static final String BUSINESSOPERATION_OLDVALUE = "oldValue";
	public static final String BUSINESSOPERATION_OPERATIONTYPE = "operationType";

	public static final String EVENTINTERESTANSWER = "EventInterestAnswer";
	public static final String EVENTINTERESTANSWER_EVENT = "event";
	public static final String EVENTINTERESTANSWER_REASON = "reason";

	public static final String EVENTINTERESTQUERY = "EventInterestQuery";
	public static final String EVENTINTERESTQUERY_EVENT = "event";
	
	public static final String WEATHERREQUEST = "WeatherRequest";
	public static final String WEATHERREQUEST_CITY = "city";
	public static final String WEATHERREQUEST_CURRENTCONDITIONS = "currentConditions";
	public static final String WEATHERREQUEST_DAYFORECASTS = "dayForecasts";
	public static final String WEATHERREQUEST_DEGREEUNIT = "degreeUnit";
	
	public static final String WEATHERRESPONSE = "WeatherResponse";
	public static final String WEATHERRESPONSE_WEATHER = "weather";
	
	public static final String FORECASTREQUEST = "ForecastRequest";
	public static final String FORECASTREQUEST_CITY = "city";
	public static final String FORECASTREQUEST_DATE = "date";
	public static final String FORECASTREQUEST_DEGREEUNIT = "degreeUnit";
	
	public static final String FORECASTRESPONSE = "ForecastResponse";
	public static final String FORECASTRESPONSE_DAYFORCAST = "dayForecast";
	public static final String FORECASTRESPONSE_HEAD = "head";
	public static final String FORECASTRESPONSE_LOCATION = "location";
	
	public static final String AVAILABILITYQUERY = "AvailabilityQuery";
	public static final String AVAILABILITYQUERY_START = "start";
	public static final String AVAILABILITYQUERY_END = "end";
	
	public static final String AVAILABILITYANSWER = "AvailabilityAnswer";
	public static final String AVAILABILITYANSWER_AVAILABLE = "available";
	
	public static final String ALTERNATIVETIMEQUERY = "AlternativeTimeQuery";
	public static final String ALTERNATIVETIMEQUERY_START = "start";
	public static final String ALTERNATIVETIMEQUERY_DURATION = "duration";
	
	public static final String ALTERNATIVETIMEANSWER = "AlternativeTimeAnswer";
	public static final String ALTERNATIVETIMEANSWER_ALTERNATIVETIME = "alternativeTime";

}
