/*
 * Created on Jun 1, 2008
 */
package br.pucrio.olis.web;

import jade.Boot;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.context.support.WebApplicationContextUtils;

import br.pucrio.olis.business.ServiceLocator;

/**
 * @author Ingrid Nunes
 * 
 */
public class AgentListener implements ServletContextListener {

	/**
	 * <p>
	 * The <code>ServletContext</code> for this web application.
	 * </p>
	 */
	private ServletContext context = null;

	/**
	 * <p>
	 * Logging output for this plug in instance.
	 * </p>
	 */
	private Log log = LogFactory.getLog(this.getClass());

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.ServletContextListener#contextDestroyed(javax.servlet.ServletContextEvent)
	 */
	@Override
	public void contextDestroyed(ServletContextEvent event) {
		context = null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.servlet.ServletContextListener#contextInitialized(javax.servlet.ServletContextEvent)
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void contextInitialized(ServletContextEvent event) {

		log.info("Initializing agent plataform...");

		// Remember our associated ServletContext
		this.context = event.getServletContext();

		try {
			log.info("Starting Service Locator...");
			new ServiceLocator(WebApplicationContextUtils
					.getWebApplicationContext(context));

			List<String> params = new ArrayList<String>();
			params.add("-gui");
			params.add("-detect-main");
			params.add("false");

			Enumeration paramNames = context.getInitParameterNames();
			while (paramNames.hasMoreElements()) {
				String paramName = (String) paramNames.nextElement();
				if (paramName.startsWith("agent")) {
					params.add(context.getInitParameter(paramName));
				}
			}

			log.info("Plataform parameters: " + params);

			Boot.main(params.toArray(new String[0]));
		} catch (Exception e) {
			log.error("Running agent plataform", e);
			e.printStackTrace();
		}

		log.info("Agent plataform is up!");

	}

}
