/*
 * Created on Apr 26, 2008
 */
package br.pucrio.olis.web;

import java.util.Map;

import br.pucrio.olis.domain.User;

import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.Interceptor;

/**
 * <p>
 * This class is the interceptor that checks if the user is logged in the system
 * to perform secured actions.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class AuthenticationInterceptor implements Interceptor {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -2377211490964730747L;

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.opensymphony.xwork2.interceptor.Interceptor#destroy()
	 */
	public void destroy() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.opensymphony.xwork2.interceptor.Interceptor#init()
	 */
	public void init() {
	}

	/**
	 * <p>
	 * Intercept secured action to check if the user is logged in the system.
	 * </p>
	 */
	@SuppressWarnings("unchecked")
	public String intercept(ActionInvocation actionInvocation) throws Exception {
		Map session = actionInvocation.getInvocationContext().getSession();
		User user = (User) session.get(Constants.USER_KEY);
		boolean isAuthenticated = (null != user);
		if (!isAuthenticated) {
			return Action.LOGIN;
		} else {
			return actionInvocation.invoke();
		}
	}

}
