/*
 * Created on Apr 26, 2008
 */
package br.pucrio.olis.web;

/**
 * <p>
 * This interface define the web layer constants.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public interface Constants {

	// --- Tokens ----

	/**
	 * <p>
	 * The token representing a "cancel" request.
	 * </p>
	 */
	public static final String CANCEL = "cancel";

	/**
	 * <p>
	 * The token representing a "create" task.
	 * </p>
	 */
	public static final String CREATE = "Create";

	/**
	 * <p>
	 * The token representing a "delete" task.
	 * </p>
	 */
	public static final String DELETE = "Delete";

	/**
	 * <p>
	 * The token representing a "edit" task.
	 * </p>
	 */
	public static final String EDIT = "Edit";

	/**
	 * <p>
	 * The package name for this application.
	 * </p>
	 */
	public static final String PACKAGE = "br.pucrio.olis";

	/**
	 * <p>
	 * The session scope attribute under which the User object for the currently
	 * logged in user is stored.
	 * </p>
	 */
	public static final String USER_KEY = "user";

	// ---- Error Messages ----

	/**
	 * <p>
	 * A static message in case message resource is not loaded.
	 * </p>
	 */
	public static final String ERROR_MESSAGES_NOT_LOADED = "ERROR:  Message resources not loaded -- check servlet container logs for error messages.";

	/**
	 * <p>
	 * A standard key from the message resources file, to test if it is
	 * available.
	 * <p>
	 */
	public static final String ERROR_TEST_RESOURCES = "index.title";

	// ---- Log Messages ----
	
	/**
	 * <p>
	 * Message to log if a business error occurs.
	 * </p>
	 */
	public static final String LOG_BUSINESS_ERROR = " Unexpected error when accessing a business service: ";

	/**
	 * <p>
	 * Message to log if a database error occurs.
	 * </p>
	 */
	public static final String LOG_DATABASE_ERROR = " Unexpected error when accessing the database: ";
	

	/**
	 * <p>
	 * Message to log if an unexcepected error occurs.
	 * </p>
	 */
	public static final String LOG_UNEXCEPECTED_ERROR = " Unexpected error occurred: ";

}
