/*
 * Created on May 19, 2008
 */
package br.pucrio.olis.web.calendar;

import java.util.ArrayList;
import java.util.List;

import br.pucrio.olis.domain.CalendarEvent;

/**
 * <p>
 * This class represents a single day of the calendar. It has the day of month
 * and the events that will happen on it.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class CalendarDay {

	private Integer day;
	private List<CalendarEvent> events;

	/**
	 * <p>
	 * Create an instance of CalendarDay.
	 * </p>
	 */
	public CalendarDay() {
		this.events = new ArrayList<CalendarEvent>();
	}

	/**
	 * <p>
	 * Create an instance of CalendarDay.
	 * </p>
	 * 
	 * @param day
	 *            the day of month.
	 */
	public CalendarDay(Integer day) {
		this();
		this.day = day;
	}

	/**
	 * <p>
	 * Add a calendar event to this service.
	 * </p>
	 * 
	 * @param calendarEvent
	 *            the calendar event to be added.
	 */
	public void addEvent(CalendarEvent calendarEvent) {
		this.events.add(calendarEvent);
	}

	public Integer getDay() {
		return day;
	}

	public List<CalendarEvent> getEvents() {
		return events;
	}

	public void setDay(Integer day) {
		this.day = day;
	}

	public void setEvents(List<CalendarEvent> events) {
		this.events = events;
	}

}
