/*
 * Created on Apr 8, 2008
 */
package br.pucrio.olis.web.support;

import br.pucrio.olis.web.Constants;
import br.pucrio.olis.web.OlisActionSupport;

/**
 * <p>
 * This class is the Welcome action. It corresponds to the main page of the web
 * application.
 * </p>
 * 
 * @author Ingrid Nunes
 * @version 1.0
 * 
 */
public class WelcomeAction extends OlisActionSupport {

	/**
	 * <p>
	 * UID generated.
	 * </p>
	 */
	private static final long serialVersionUID = -746327776090408418L;

	/**
	 * <p>
	 * Redirect to the welcome page. Check first if the application is correctly
	 * initialized.
	 * </p>
	 */
	public String execute() {
		// Confirm message resources loaded
		String message = getText(Constants.ERROR_TEST_RESOURCES);
		if (Constants.ERROR_TEST_RESOURCES.equals(message)) {
			addActionError(Constants.ERROR_MESSAGES_NOT_LOADED);
		}

		if (hasErrors()) {
			return ERROR;
		} else {
			return SUCCESS;
		}
	}

}
